//-------------------------------------------------------------------------------------------------------
// LBGUI - by Lukas Brozio
// lbgui.h
// Version 1.0 as of 28-July-2010
//-------------------------------------------------------------------------------------------------------



/* The code doesn't have many comments. That's just my style. So be careful if you want to edit the code.

Maybe you can find functions in here that you find useful, but aren't documented in the manual, because
they are meant to be only used internally. If you use them directly, I don't garuantee they work for you
the way you expected. If you think a function in this script is so useful, that it should be documented
in the manual, you can contact me.*/




#ifndef lbgui_h // Don't include twice
#define lbgui_h
// Please note that the subscripts of lbgui.h are NOT protected against including twice.


#include "lbgui_structs.h"
#include "lbgui_flags.h"




FONT* LBG_window_font = "Arial#24b";
FONT* LBG_button_font = "Arial#24b";
FONT* LBG_checkbox_font = "Arial#24b";
FONT* LBG_infobox_font = "Arial#16";
FONT* LBG_progressbar_font = "Arial#24b";
FONT* LBG_listitem_font = "Arial#24b";
FONT* LBG_editbox_font = "Arial#24b";
FONT* LBG_digits_font = "Arial#24b";






#ifndef LBG_lowest_layer
	#define LBG_lowest_layer 10
#endif
#ifndef LBG_highest_layer
	#define LBG_highest_layer 1000
#endif
#ifndef LBG_winlayer
	#define LBG_winlayer 10
#endif
#ifndef LBG_layer_step
	#define LBG_layer_step 10
#endif
#ifndef LBG_butlayer_step
	#define LBG_butlayer_step 2
#endif

#ifndef LBG_screenpos_x
	#define LBG_screenpos_x 0
#endif
#ifndef LBG_screenpos_y
	#define LBG_screenpos_y 0
#endif
#ifndef LBG_screensize_x
	#define LBG_screensize_x screen_size.x
#endif
#ifndef LBG_screensize_y
	#define LBG_screensize_y screen_size.y
#endif





void LBG_event();
int LBG_condition();

var LBG_mouse_lastpos_x;
var LBG_mouse_lastpos_y;

#define LBG_mouse_moved ((LBG_mouse_lastpos_x != mouse_pos.x) || (LBG_mouse_lastpos_y != mouse_pos.y))
#define LBG_mouse_didnt_move ((LBG_mouse_lastpos_x == mouse_pos.x) && (LBG_mouse_lastpos_y == mouse_pos.y))


STRING* LBG_str_temp = "";

BMAP* LBG_empty_bmap;


var LBG_mouse_cursor = 0;
// 0 = standard
// 1 = over button
// 2 = horizontal scale
// 3 = vertical scale
// 4 = diagonal topleft-buttonright scale
// 5 = diagonal topright-buttonleft scale
// 6 = over an editbox

void LBG_stop_action ()
{
	LBG_flags |= LBGUI_STOPACTION;
}



var LBG_mouse_pos_x ()
{
	if(LBG_flags & LBGUI_PROTECTMOUSE) return(maxv(minv(mouse_pos.x+mouse_spot.x,LBG_screenpos_x+LBG_screensize_x-1),LBG_screenpos_x));
	return mouse_pos.x-mouse_spot.x;
}
var LBG_mouse_pos_y ()
{
	if(LBG_flags & LBGUI_PROTECTMOUSE) return(maxv(minv(mouse_pos.y+mouse_spot.y,LBG_screenpos_y+LBG_screensize_y-1),LBG_screenpos_y));
	return mouse_pos.y-mouse_spot.y;
}


var LBG_str_num_lines (STRING* str)
{
	var ret = 1;
	var x;
	str_cpy(LBG_str_temp,str);
	while(1)
	{
		if(!str_len(LBG_str_temp)) break;
		x = str_stri(LBG_str_temp,"\n");
		if(!x) break;
		ret++;
		str_clip(LBG_str_temp,x);
	}
	return(ret);
}






#include "lbgui_objfunc.h"
#include "lbgui_buttonfunc.h"
#include "lbgui_panelfunc.h"
#include "lbgui_textfunc.h"
#include "lbgui_checkfunc.h"
#include "lbgui_infofunc.h"
#include "lbgui_progressfunc.h"
#include "lbgui_hscrollfunc.h"
#include "lbgui_vscrollfunc.h"
#include "lbgui_sliderfunc.h"
#include "lbgui_listfunc.h"
#include "lbgui_rightclickfunc.h"
#include "lbgui_digitsfunc.h"
#include "lbgui_editfunc.h"
#include "lbgui_comboboxfunc.h"
#include "lbgui_windowfunc.h"




void LBGUI_open ()
{
	if(LBG_flags & LBGUI_RUNNING) return;
	LBG_flags |= LBGUI_RUNNING;
	
	LBG_WINDOW_FIRST = 0;
	LBG_BUTTON_FIRST = 0;
	LBG_PANEL_FIRST = 0;
	LBG_TEXT_FIRST = 0;
	LBG_CHECKBOX_FIRST = 0;
	LBG_INFOBOX_FIRST = 0;
	LBG_PROGRESSBAR_FIRST = 0;
	LBG_HSCROLLBAR_FIRST = 0;
	LBG_VSCROLLBAR_FIRST = 0;
	LBG_SLIDER_FIRST = 0;
	LBG_LISTBOX_FIRST = 0;
	LBG_RIGHTCLICK_FIRST = 0;
	LBG_COMBOBOX_FIRST = 0;
	LBG_DIGITS_FIRST = 0;
	LBG_EDITBOX_FIRST = 0;
	
	
	LBG_BUTTON* but = LBG_BUTTON_FIRST;
	LBG_WINDOW* win = LBG_WINDOW_FIRST;
	LBG_PANEL* pan = LBG_PANEL_FIRST;
	LBG_TEXT* txt = LBG_TEXT_FIRST;
	LBG_CHECKBOX* cbx = LBG_CHECKBOX_FIRST;
	LBG_INFOBOX* ifo = LBG_INFOBOX_FIRST;
	LBG_PROGRESSBAR* prg = LBG_PROGRESSBAR_FIRST;
	LBG_HSCROLLBAR* hsb = LBG_HSCROLLBAR_FIRST;
	LBG_VSCROLLBAR* vsb = LBG_VSCROLLBAR_FIRST;
	LBG_SLIDER* sli = LBG_SLIDER_FIRST;
	LBG_LISTBOX* lst = LBG_LISTBOX_FIRST;
	LBG_RIGHTCLICK* rcl = LBG_RIGHTCLICK_FIRST;
	LBG_COMBOBOX* cbb = LBG_COMBOBOX_FIRST;
	LBG_DIGITS* dgts = LBG_DIGITS_FIRST;
	LBG_EDITBOX* ebx = LBG_EDITBOX_FIRST;
	
	LBG_mouse_lastpos_x = mouse_pos.x;
	LBG_mouse_lastpos_y = mouse_pos.y;
	
	LBG_empty_bmap = bmap_createblack(1,1,32);
	bmap_fill(LBG_empty_bmap,nullvector,0);
	
	
	proc_mode = PROC_LATE;
	
	LBG_editbox_inchar_loop();
	
	while(1)
	{
		LBG_mouse_cursor = 0;
		
		
		
		win = LBG_WINDOW_FIRST;
		while(win)
		{
			win = LBG_manage_window(win);
		}
		hsb = LBG_HSCROLLBAR_FIRST;
		while(hsb)
		{
			hsb = LBG_manage_hscrollbar(hsb);
		}
		vsb = LBG_VSCROLLBAR_FIRST;
		while(vsb)
		{
			vsb = LBG_manage_vscrollbar(vsb);
		}
		cbb = LBG_COMBOBOX_FIRST;
		while(cbb)
		{
			cbb = LBG_manage_combobox(cbb);
		}
		but = LBG_BUTTON_FIRST;
		while(but)
		{
			but = LBG_manage_button(but);
		}
		pan = LBG_PANEL_FIRST;
		while(pan)
		{
			pan = LBG_manage_panel(pan);
		}
		txt = LBG_TEXT_FIRST;
		while(txt)
		{
			txt = LBG_manage_text(txt);
		}
		cbx = LBG_CHECKBOX_FIRST;
		while(cbx)
		{
			cbx = LBG_manage_checkbox(cbx);
		}
		ifo = LBG_INFOBOX_FIRST;
		while(ifo)
		{
			ifo = LBG_manage_infobox(ifo);
		}
		prg = LBG_PROGRESSBAR_FIRST;
		while(prg)
		{
			prg = LBG_manage_progressbar(prg);
		}
		sli = LBG_SLIDER_FIRST;
		while(sli)
		{
			sli = LBG_manage_slider(sli);
		}
		lst = LBG_LISTBOX_FIRST;
		while(lst)
		{
			lst = LBG_manage_listbox(lst);
		}
		rcl = LBG_RIGHTCLICK_FIRST;
		while(rcl)
		{
			rcl = LBG_manage_rightclick(rcl);
		}
		dgts = LBG_DIGITS_FIRST;
		while(dgts)
		{
			dgts = LBG_manage_digits(dgts);
		}
		ebx = LBG_EDITBOX_FIRST;
		while(ebx)
		{
			ebx = LBG_manage_editbox(ebx);
		}
		
		
		
		LBG_mouse_lastpos_x = mouse_pos.x;
		LBG_mouse_lastpos_y = mouse_pos.y;
		
		if(!(LBG_flags & LBGUI_RUNNING)) return;
		wait(1);
	}
}


void LBGUI_close ()
{
	LBG_flags &= ~LBGUI_RUNNING;
	
	
	proc_kill(LBGUI_open);
	proc_kill(LBG_editbox_inchar_loop);
	
	LBG_BUTTON* but = LBG_BUTTON_FIRST;
	LBG_WINDOW* win = LBG_WINDOW_FIRST;
	LBG_PANEL* pan = LBG_PANEL_FIRST;
	LBG_TEXT* txt = LBG_TEXT_FIRST;
	LBG_CHECKBOX* cbx = LBG_CHECKBOX_FIRST;
	LBG_INFOBOX* ifo = LBG_INFOBOX_FIRST;
	LBG_PROGRESSBAR* prg = LBG_PROGRESSBAR_FIRST;
	LBG_HSCROLLBAR* hsb = LBG_HSCROLLBAR_FIRST;
	LBG_VSCROLLBAR* vsb = LBG_VSCROLLBAR_FIRST;
	LBG_SLIDER* sli = LBG_SLIDER_FIRST;
	LBG_LISTBOX* lst = LBG_LISTBOX_FIRST;
	LBG_RIGHTCLICK* rcl = LBG_RIGHTCLICK_FIRST;
	LBG_COMBOBOX* cbb = LBG_COMBOBOX_FIRST;
	LBG_DIGITS* dgts = LBG_DIGITS_FIRST;
	LBG_EDITBOX* ebx = LBG_EDITBOX_FIRST;
	
	win = LBG_WINDOW_FIRST;
	while(win)
	{
		win = LBG_destroy_window(win);
	}
	hsb = LBG_HSCROLLBAR_FIRST;
	while(hsb)
	{
		hsb = LBG_destroy_hscrollbar(hsb);
	}
	vsb = LBG_VSCROLLBAR_FIRST;
	while(vsb)
	{
		vsb = LBG_destroy_vscrollbar(vsb);
	}
	cbb = LBG_COMBOBOX_FIRST;
	while(cbb)
	{
		cbb = LBG_destroy_combobox(cbb);
	}
	ebx = LBG_EDITBOX_FIRST;
	while(ebx)
	{
		ebx = LBG_destroy_editbox(ebx);
	}
	but = LBG_BUTTON_FIRST;
	while(but)
	{
		but = LBG_destroy_button(but);
	}
	pan = LBG_PANEL_FIRST;
	while(pan)
	{
		pan = LBG_destroy_panel(pan);
	}
	txt = LBG_TEXT_FIRST;
	while(txt)
	{
		txt = LBG_destroy_text(txt);
	}
	cbx = LBG_CHECKBOX_FIRST;
	while(cbx)
	{
		cbx = LBG_destroy_checkbox(cbx);
	}
	ifo = LBG_INFOBOX_FIRST;
	while(ifo)
	{
		ifo = LBG_destroy_infobox(ifo);
	}
	prg = LBG_PROGRESSBAR_FIRST;
	while(prg)
	{
		prg = LBG_destroy_progressbar(prg);
	}
	sli = LBG_SLIDER_FIRST;
	while(sli)
	{
		sli = LBG_destroy_slider(sli);
	}
	lst = LBG_LISTBOX_FIRST;
	while(lst)
	{
		lst = LBG_destroy_listbox(lst);
	}
	rcl = LBG_RIGHTCLICK_FIRST;
	while(rcl)
	{
		rcl = LBG_destroy_rightclick(rcl);
	}
	dgts = LBG_DIGITS_FIRST;
	while(dgts)
	{
		dgts = LBG_destroy_digits(dgts);
	}
	
	ptr_remove(LBG_empty_bmap);
}

#endif
