void LBG_checkbox_reset_size_x (LBG_CHECKBOX* cbx)
{
	cbx.size_x = maxv(bmap_width(cbx->panel->bmap),cbx->tpos_x + str_width(cbx->caption,cbx->text->font));
}

LBG_CHECKBOX* LBG_create_checkbox (LBG_WINDOW* _parent, var pos_x, var pos_y, var tpos_x, var tpos_y, STRING* caption, LBG_CHECKBOX_BMAPS* bmaps, long flags)
{
	LBG_CHECKBOX* cbx = malloc(sizeof(LBG_CHECKBOX));
	cbx->ssize = sizeof(LBG_CHECKBOX);
	cbx->stype = 6;
	
	if(flags & CF_EXTERNSTRING)
	{
		cbx->caption = caption;
	}
	else
	{
		cbx->caption = str_create("");
		str_cpy(cbx->caption,caption);
	}
	
	
	cbx->parent = _parent;
	cbx->layer = 0;
	cbx->flags = flags;
	
	cbx->text = txt_create(1,LBG_object_calc_text_layer(cbx));
	ptr_remove((cbx->text->pstring)[0]);
	(cbx->text->pstring)[0] = cbx->caption;
	
	cbx->text->font = LBG_checkbox_font;
	
	
	cbx->tpos_x = tpos_x;
	cbx->tpos_y = tpos_y;
	
	cbx->color_default.red = 255;
	cbx->color_default.green = 255;
	cbx->color_default.blue = 255;
	
	cbx->color_over.red = 255;
	cbx->color_over.green = 255;
	cbx->color_over.blue = 255;
	
	cbx->color_clicked.red = 255;
	cbx->color_clicked.green = 255;
	cbx->color_clicked.blue = 255;
	
	cbx->color_disabled.red = 255;
	cbx->color_disabled.green = 255;
	cbx->color_disabled.blue = 255;
	
	
	cbx->pos_x = pos_x;
	cbx->pos_y = pos_y;
	
	cbx->scale_x = 1;
	cbx->scale_y = 1;
	
	cbx->panel = pan_create("",LBG_object_calc_panel_layer(cbx));
	cbx->bmap_default = bmaps->bmap_default;
	cbx->bmap_over = bmaps->bmap_over;
	cbx->bmap_checked = bmaps->bmap_checked;
	cbx->bmap_checked_over = bmaps->bmap_checked_over;
	cbx->bmap_disabled = bmaps->bmap_disabled;
	cbx->bmap_checked_disabled = bmaps->bmap_checked_disabled;
	
	cbx->size_y = bmap_height(cbx->bmap_default);
	
	
	cbx->panel->bmap = cbx->bmap_default;
	cbx->panel->pos_x = cbx->pos_x;
	cbx->panel->pos_y = cbx->pos_y;
	
	cbx->text->pos_x = cbx->pos_x + cbx->tpos_x;
	cbx->text->pos_y = cbx->pos_y + cbx->tpos_y;
	
	if(cbx->flags & CF_SHOW)
	{
		cbx->panel->flags |= SHOW;
		cbx->text->flags |= SHOW;
	}
	
	
	
	
	
	
	cbx->next = NULL;
	if(LBG_CHECKBOX_FIRST == NULL)
	{
		LBG_CHECKBOX_FIRST = cbx;
		cbx->previous = NULL;
	}
	else
	{
		cbx->previous = LBG_object_last(LBG_CHECKBOX_FIRST);
		cbx->previous->next = cbx;
	}
	
	
	LBG_object_upate_size (cbx);
	
	LBG_checkbox_reset_size_x(cbx);
	
	cbx->Destroy = 0;
	cbx->ChangeState = 0;
	cbx->Over = 0;
	cbx->Leave = 0;
	cbx->Condition = 0;
	
	cbx->group = 0;
	
	return (cbx);
}






void LBG_cbmaps_destroy_2frames (LBG_CHECKBOX_BMAPS* bmaps) // for internal use
{
	wait(2);
	free(bmaps);
}

LBG_CHECKBOX_BMAPS* LBG_cbmaps (BMAP* bmap_default, BMAP* bmap_over, BMAP* bmap_checked, BMAP* bmap_checked_over, BMAP* bmap_disabled, BMAP* bmap_checked_disabled)
{
	LBG_CHECKBOX_BMAPS* bmaps = malloc(sizeof(LBG_CHECKBOX_BMAPS));
	bmaps->bmap_default = bmap_default;
	bmaps->bmap_over = bmap_over;
	bmaps->bmap_checked = bmap_checked;
	bmaps->bmap_checked_over = bmap_checked_over;
	bmaps->bmap_disabled = bmap_disabled;
	bmaps->bmap_checked_disabled = bmap_checked_disabled;
	LBG_cbmaps_destroy_2frames(bmaps);
	return(bmaps);
}


void LBG_update_checkbox_layer (LBG_CHECKBOX* cbx)
{
	var x;
	x = LBG_object_calc_panel_layer(cbx);
	if(cbx->panel->layer != x) layer_sort(cbx->panel,x);
	x = LBG_object_calc_text_layer(cbx);
	if(cbx->text->layer != x) layer_sort(cbx->text,x);
}




void LBG_checkbox_execute (LBG_CHECKBOX* cbx, void* func)
{
	if(func != 0)
	{
		LBG_event_object = cbx;
		LBG_event_checkbox = cbx;
		LBG_event = func;
		LBG_event();
	}
}

int LBG_checkbox_condition (LBG_BUTTON* cbx, void* func)
{
	if(func != 0)
	{
		LBG_event_object = cbx;
		LBG_event_checkbox = cbx;
		LBG_condition = func;
		return LBG_condition();
	}
	return 1;
}

void LBG_checkbox_event (LBG_CHECKBOX* cbx)
{
	cbx.flags &= ~CF_EVENT;
	if(!key_pressed(280)) return;
	LBG_HANDLE* h = LBG_get_eventhandle(cbx);
	wait(1);
	if(!h->valid)
	{
		LBG_destroy_handle(h);
		return;
	}
	if(!key_pressed(280))
	{
		cbx->flags |= CF_EVENT;
		if((cbx->flags & CF_CHECKED) && (!(cbx->flags & CF_RADIO))) cbx->flags &= ~CF_CHECKED;
		else
		{
			cbx->flags |= CF_CHECKED;
			if(cbx->flags & CF_RADIO)
			{
				
				LBG_CHECKBOX* cbx1 = LBG_CHECKBOX_FIRST;
				while(cbx1)
				{
					if ((cbx1->parent == cbx->parent) && (cbx1->group == cbx->group) && (cbx1 != cbx) && (cbx1->flags & CF_RADIO)) cbx1->flags &= ~CF_CHECKED;
					cbx1 = cbx1->next;
				}
			}
		}
		LBG_checkbox_execute(cbx,cbx->ChangeState);
		wait(1);
		if(!h->valid)
		{
			LBG_destroy_handle(h);
			return;
		}
		cbx->flags &= ~CF_EVENT;
	}
	LBG_destroy_handle(h);
}




LBG_CHECKBOX* LBG_manage_checkbox (LBG_CHECKBOX* cbx)
{
	LBG_object_upate_pos(cbx);
	LBG_object_upate_size(cbx);
	LBG_update_checkbox_layer(cbx);
	
	
	vec_set(cbx->text->blue,cbx->color_default);
	
	if (!(cbx->flags & CF_DISABLED))
	{
		if (!(key_pressed(280)))
		{
			cbx->flags &= ~CFi_CLICK0;
			cbx->flags &= ~CFi_CLICK1;
			cbx->flags &= ~CF_CLICKED;
		}
		
		if (LBG_not_disabled_by_disableflag(cbx) && LBG_checkbox_condition(cbx,cbx->Condition) && LBG_mouse_over_object(cbx) && (cbx->parent == LBG_mouse_window()) && LBG_window_mouse_over_content (cbx->parent) && (((!(cbx->flags & CFi_CLICK0)) && (!(cbx->flags & CFi_CLICK1))) || ((!(cbx->flags & CFi_CLICK0)) && ((cbx->flags & CFi_CLICK1))))) // ((cbx_click == 0) || (cbx_click == 2))
		{
			if(!(cbx->flags & CFi_OVER)) LBG_checkbox_execute(cbx,cbx->Over);
			cbx->flags |= CFi_OVER;
			if(cbx->flags & CF_CHECKED) cbx->panel.bmap = cbx->bmap_checked_over;
			else cbx->panel.bmap = cbx->bmap_over;
			vec_set(cbx->text->blue,cbx->color_over);
			if (key_pressed(280))
			{
				cbx->flags &= ~CFi_CLICK0;
				cbx->flags |= CFi_CLICK1;
				cbx->flags |= CF_CLICKED;
				if((cbx->flags & CF_CHECKED) && (!(cbx->flags & CF_RADIO))) cbx->panel.bmap = cbx->bmap_over;
				else cbx->panel.bmap = cbx->bmap_checked_over;
				vec_set(cbx->text->blue,cbx->color_clicked);
				LBG_checkbox_event(cbx);
			}
		}
		else
		{
			if(cbx->flags & CF_CHECKED) cbx->panel.bmap = cbx->bmap_checked;
			else cbx->panel.bmap = cbx->bmap_default;
			cbx.flags &= ~CF_EVENT;
			if(cbx->flags & CFi_OVER) LBG_checkbox_execute(cbx,cbx->Leave);
			cbx->flags &= ~CFi_OVER;
			cbx->flags &= ~CF_CLICKED;
		}
		if ((!(cbx->flags & CFi_CLICK0)) && (!(cbx->flags & CFi_CLICK1)) && (key_pressed(280)))
		{
			cbx->flags |= CFi_CLICK0;
			cbx->flags &= ~CFi_CLICK1;
			cbx->flags &= ~CF_CLICKED;
		}
		
	}
	else
	{
		cbx->flags |= CFi_CLICK0;
		cbx->flags &= ~CFi_CLICK1;
		cbx->flags &= ~CFi_OVER;
		cbx->flags &= ~CF_CLICKED;
		if(cbx->flags & CF_CHECKED) cbx->panel.bmap = cbx->bmap_checked_disabled;
		else cbx->panel.bmap = cbx->bmap_disabled;
		vec_set(cbx->text->blue,cbx->color_disabled);
	}
	
	
	if(cbx->flags & CF_SHOW)
	{
		cbx->panel->flags |= SHOW;
		cbx->text->flags |= SHOW;
	}
	else
	{
		cbx->panel->flags &= ~SHOW;
		cbx->text->flags &= ~SHOW;
	}
	
	
	return cbx->next;
}





LBG_CHECKBOX* LBG_destroy_checkbox (LBG_CHECKBOX* cbx)
{
	LBG_checkbox_execute(cbx,cbx->Destroy);
	
	if(!(cbx->flags & CF_EXTERNSTRING)) ptr_remove(cbx->caption);
	ptr_remove(cbx->text);
	ptr_remove(cbx->panel);
	
	LBG_object_destroy_infoboxes(cbx);
	LBG_object_destroy_rightclicks(cbx);
	
	LBG_CHECKBOX* next = cbx->next;
	if(cbx->previous) cbx->previous->next = cbx->next;
	else LBG_CHECKBOX_FIRST = cbx->next;
	if(cbx->next) cbx->next->previous = cbx->previous;
	
	LBG_object_make_handles_invalid(cbx);
	free(cbx);
	return(next);
}


void LBG_update_checkbox (LBG_CHECKBOX* cbx)
{
	LBG_object_upate_pos(cbx);
	LBG_object_upate_size(cbx);
	LBG_update_checkbox_layer(cbx);
}