LBG_DIGITS* LBG_create_digits (LBG_WINDOW* _parent, var pos_x, var pos_y, STRING* format, var value, long flags)
{
	LBG_DIGITS* dgts = malloc(sizeof(LBG_DIGITS));
	dgts->ssize = sizeof(LBG_DIGITS);
	dgts->stype = 17;
	
	dgts->parent = _parent;
	dgts->layer = 0;
	dgts->flags = flags;
	
	
	dgts->pos_x = pos_x;
	dgts->pos_y = pos_y;
	
	dgts->scale_x = 1;
	dgts->scale_y = 1;
	
	
	if(flags & DF_EXTERNVAR)
	{
		dgts->value = *((var*)value);
		dgts->v = value;
	}
	else
	{
		dgts->value = value;
		dgts->v = NULL;
	}
	
	if(flags & DF_EXTERNFORMAT)
	{
		dgts->format = format;
	}
	else
	{
		dgts->format = str_create("");
		str_cpy(dgts->format,format);
	}
	
	dgts->text = txt_create(1,LBG_object_calc_text_layer(dgts));
	dgts->text->font = LBG_digits_font;
	dgts->caption = (dgts->text->pstring)[0];
	
	dgts->size_x = dgts->text->size_x;
	dgts->size_y = dgts->text->size_y;
	
	
	dgts->text->pos_x = dgts->pos_x;
	dgts->text->pos_y = dgts->pos_y;
	
	if(dgts->flags & DF_SHOW)
	{
		if(dgts->text) dgts->text.flags |= SHOW;
	}
	
	
	dgts->Destroy = 0;
	
	
	dgts->next = NULL;
	if(LBG_DIGITS_FIRST == NULL)
	{
		LBG_DIGITS_FIRST = dgts;
		dgts->previous = NULL;
	}
	else
	{
		dgts->previous = LBG_object_last(LBG_DIGITS_FIRST);
		dgts->previous->next = dgts;
	}
	
	return (dgts);
}




void LBG_update_digits_layer (LBG_DIGITS* dgts)
{
	var x;
	x = LBG_object_calc_text_layer(dgts);
	if(dgts->text->layer != x) layer_sort(dgts->text,x);
}

LBG_DIGITS* LBG_manage_digits (LBG_DIGITS* dgts)
{ 
	LBG_object_upate_pos(dgts);
	LBG_object_upate_size(dgts);
	LBG_update_digits_layer(dgts);
	
	if(dgts->flags & DF_EXTERNVAR) dgts->value = *(dgts->v);
	str_printf((dgts->text->pstring)[0], _chr(dgts->format),(double)dgts->value);
	
	
	if(dgts->flags & DF_SHOW)
	{
		dgts->text->flags |= SHOW;
	}
	else
	{
		dgts->text->flags &= ~SHOW;
	}
	return dgts->next;
}



void LBG_update_digits (LBG_DIGITS* dgts)
{
	LBG_object_upate_pos(dgts);
	LBG_object_upate_size(dgts);
	LBG_update_digits_layer(dgts);
}

void LBG_digits_execute (LBG_DIGITS* dgts, void* func)
{
	if(func != 0)
	{
		LBG_event_object = dgts;
		LBG_event_digits = dgts;
		LBG_event = func;
		LBG_event();
	}
}



LBG_DIGITS* LBG_destroy_digits (LBG_DIGITS* dgts)
{
	LBG_digits_execute(dgts,dgts->Destroy);
	
	ptr_remove(dgts->text);
	
	LBG_DIGITS* next = dgts->next;
	if(dgts->previous) dgts->previous->next = dgts->next;
	else LBG_DIGITS_FIRST = dgts->next;
	if(dgts->next) dgts->next->previous = dgts->previous;
	
	free(dgts);
	LBG_object_make_handles_invalid(dgts);
	return(next);
}
