void LBG_hscrollbar_bitmap (BMAP* _bmap, LBG_HSCROLLBAR_BMAPS* bmaps, var size_x, var size_y) // For internal use
{
	bmap_blit(_bmap,bmaps->bmap_left,vector(0,0,0),NULL);
	bmap_blit(_bmap,bmaps->bmap_right,vector(size_x-bmap_width(bmaps->bmap_right),0,0),NULL);
	bmap_blit(_bmap,bmaps->bmap_middle,vector(bmap_width(bmaps->bmap_left),0,0),vector(size_x-bmap_width(bmaps->bmap_left)-bmap_width(bmaps->bmap_right),bmap_height(bmaps->bmap_middle),0));
}



void LBG_update_window (LBG_WINDOW* win);
LBG_HSCROLLBAR* LBG_create_hscrollbar (LBG_WINDOW* _target, LBG_HSCROLLBAR_BMAPS* bmaps, LBG_BUTTON_BMAPS* blbmaps, LBG_BUTTON_BMAPS* brbmaps, long flags)
{
	LBG_HSCROLLBAR* hsb = malloc(sizeof(LBG_HSCROLLBAR));
	hsb->ssize = sizeof(LBG_HSCROLLBAR);
	hsb->stype = 9;
	
	
	
	
	hsb->target = _target;
	hsb->layer = 0;
	hsb->flags = flags;
	
	
	
	hsb->scale_x = 1;
	hsb->scale_y = 1;
	
	hsb->panel = pan_create("",LBG_object_calc_panel_layer(hsb));
	hsb->bmaps.bmap_left = bmaps->bmap_left;
	hsb->bmaps.bmap_middle = bmaps->bmap_middle;
	hsb->bmaps.bmap_right = bmaps->bmap_right;
	hsb->bmaps.bmap_bar = bmaps->bmap_bar;
	hsb->bmaps.bmap_corner = bmaps->bmap_corner;
	
	
	hsb->panel->bmap = hsb->bmaps.bmap_bar;
	
	
	if(hsb->target)
	switch(hsb->target->stype)
	{
		case 1:
			hsb->ppa = 0.2;
			hsb->wheelspeed = 5;
		break;
		
		default:
			hsb->ppa = 1;
			hsb->wheelspeed = 1;
		break;
	}
	
	
	hsb->size_x = 32;
	hsb->size_y = bmap_height(hsb->bmaps.bmap_bar);
	hsb->scrollbar = pan_create("",LBG_object_calc_panel_layer(hsb)+1);
	hsb->scrollbar->bmap = bmap_createblack(hsb->size_x,hsb->size_y,32);
	LBG_hscrollbar_bitmap(hsb->scrollbar->bmap,bmaps,hsb->size_x,hsb->size_y);
	
	hsb->corner = pan_create("",LBG_object_calc_panel_layer(hsb)+1);
	if(hsb->bmaps.bmap_corner) hsb->corner->bmap = hsb->bmaps.bmap_corner;
	else hsb->corner->bmap = hsb->bmaps.bmap_left;
	
	
	
	
	
	hsb->button_left = LBG_create_button(hsb,0,0,0,0,"",blbmaps,0,BF_SHOW | BFi_SCROLLBAR);
	hsb->button_right = LBG_create_button(hsb,0,0,0,0,"",brbmaps,0,BF_SHOW | BFi_SCROLLBAR);
	
	
	
	if(hsb->flags & PBF_SHOW)
	{
		hsb->panel->flags |= SHOW;
		hsb->scrollbar->flags |= SHOW;
		hsb->button_left->flags |= BF_SHOW;
	}
	
	
	hsb->scrollamount = 0;
	hsb->scrollmax = 0;
	hsb->buttonspeed = 5;
	
	
	
	hsb->next = NULL;
	if(LBG_HSCROLLBAR_FIRST == NULL)
	{
		LBG_HSCROLLBAR_FIRST = hsb;
		hsb->previous = NULL;
	}
	else
	{
		hsb->previous = LBG_object_last(LBG_HSCROLLBAR_FIRST);
		hsb->previous->next = hsb;
	}
	
	
	LBG_object_upate_size (hsb);
	
	switch(hsb->target->stype)
	{
		case 1:
		hsb->target->flags |= WF_HSCROLLBAR;
		LBG_update_window(hsb->target);
		break;
	}
	
	hsb->Destroy = 0;
	hsb->Scrolling = 0;
	hsb->Condition = 0;
	
	
	return (hsb);
}


void LBG_update_hscrollbar_layer (LBG_HSCROLLBAR* hsb)
{
	var x;
	x = LBG_object_calc_panel_layer(hsb);
	if(hsb->panel->layer != x) layer_sort(hsb->panel,x);
	x = LBG_object_calc_panel_layer(hsb)+1;
	if(hsb->scrollbar->layer != x) layer_sort(hsb->scrollbar,x);
	x = LBG_object_calc_panel_layer(hsb);
	if(hsb->corner->layer != x) layer_sort(hsb->corner,x);
	LBG_update_button_layer (hsb->button_left);
	LBG_update_button_layer (hsb->button_right);
}



var LBG_hscrollbar_get_minwidth(LBG_HSCROLLBAR* hsb)
{
	return(bmap_width(hsb->bmaps.bmap_left) + bmap_width(hsb->bmaps.bmap_middle) + bmap_width(hsb->bmaps.bmap_right));
}
var LBG_hscrollbar_get_maxwidth(LBG_HSCROLLBAR* hsb)
{
	return(hsb->size_x - hsb->button_left->size_x - hsb->button_right->size_x);
}


void LBG_hscrollbar_calc_barwidth(LBG_HSCROLLBAR* hsb)
{
	hsb->scrollbar->size_x = integer(maxv(LBG_hscrollbar_get_minwidth(hsb),LBG_hscrollbar_get_maxwidth(hsb) - hsb->scrollmax*hsb->ppa)+0.5);
}


int LBG_mouse_over_hscrollbar_move(LBG_HSCROLLBAR* hsb)
{
	if(hsb) return ((mouse_pos.x >= hsb->scrollbar->pos_x) && (mouse_pos.x < hsb->scrollbar->pos_x + hsb->scrollbar->size_x) && (mouse_pos.y >= hsb->scrollbar->pos_y) && (mouse_pos.y < hsb->scrollbar->pos_y + hsb->scrollbar->size_y) && (LBG_mouse_window() == hsb->target));
	else return 0;
}



void LBG_hscrollbar_execute (LBG_HSCROLLBAR* hsb, void* func)
{
	if(func != 0)
	{
		LBG_event_object = hsb;
		LBG_event_scrollbar = hsb;
		LBG_event_hscrollbar = hsb;
		LBG_event = func;
		LBG_event();
	}
}

int LBG_hscrollbar_condition (LBG_HSCROLLBAR* hsb, void* func)
{
	if(func != 0)
	{
		LBG_event_object = hsb;
		LBG_event_scrollbar = hsb;
		LBG_event_hscrollbar = hsb;
		LBG_condition = func;
		return LBG_condition();
	}
	return 1;
}

LBG_WINDOW* LBG_scrollbar_parent_window(LBG_HSCROLLBAR* sb)
{
	LBG_WINDOW* p = sb->target;
	while(p)
	{
		if(p->stype == 1) break;
		p = p->parent;
	}
	return p;
}

int LBG_hscrollbar_mouse_for_wheel (LBG_HSCROLLBAR* hsb);
int LBG_vscrollbar_mouse_for_wheel (LBG_VSCROLLBAR* vsb);
int LBG_scrollbar_no_other (LBG_HSCROLLBAR* sb)
{
	if(sb->target->stype != 1) return 1;
	LBG_HSCROLLBAR* hsb = LBG_HSCROLLBAR_FIRST;
	while(hsb)
	{
		if((LBG_scrollbar_parent_window(hsb) == sb->target) && (!((hsb == sb) || (hsb->target == sb->target) || (hsb->target->stype == 1)))) if (LBG_hscrollbar_mouse_for_wheel(hsb))
		return 0;
		hsb = hsb->next;
	}
	LBG_VSCROLLBAR* vsb = LBG_VSCROLLBAR_FIRST;
	while(vsb)
	{
		if((LBG_scrollbar_parent_window(vsb) == sb->target) && (!((vsb == sb) || (vsb->target == sb->target) || (vsb->target->stype == 1)))) if (LBG_vscrollbar_mouse_for_wheel(vsb))
		return 0;
		vsb = vsb->next;
	}
	return 1;
}


int LBG_hscrollbar_mouse_for_wheel (LBG_HSCROLLBAR* hsb)
{
	if(hsb->target)
	switch(hsb->target->stype)
	{
		case 1:
			if(!LBG_scrollbar_no_other(hsb)) return 0;
			return(LBG_window_mouse_over_content(hsb->target) && (LBG_mouse_window() == hsb->target) && LBG_hscrollbar_condition(hsb,hsb->Condition));
		break;
		default: return 0;
	}
}





LBG_HSCROLLBAR* LBG_manage_hscrollbar (LBG_HSCROLLBAR* hsb)
{
	int target_vscroll = 0;
	LBG_update_hscrollbar_layer(hsb);
	
	if(hsb->target)
	switch(hsb->target->stype)
	{
		case 1:
			target_vscroll = hsb->target->flags & WF_VSCROLLBAR;
		break;
		default: return 0;
	}
	
	
	if ((!((hsb->flags & HSF_DISABLED) || (hsb->flags & HSF_AUTODISABLED))) && (hsb->target->flags & WF_HSCROLLBAR) && LBG_not_disabled_by_disableflag(hsb))
	{
		
		if (!(key_pressed(280)))
		{
			hsb->flags &= ~HSFi_CLICK0;
			hsb->flags &= ~HSFi_CLICK1;
		}
		if (LBG_mouse_over_hscrollbar_move(hsb) && (((!(hsb->flags & HSFi_CLICK0)) && (!(hsb->flags & HSFi_CLICK1))) || ((!(hsb->flags & HSFi_CLICK0)) && ((hsb->flags & HSFi_CLICK1)))))
		{
			hsb->flags |= HSFi_OVER;
			if (key_pressed(280))
			{
				if(!((!(hsb->flags & HSFi_CLICK0)) && ((hsb->flags & HSFi_CLICK1))))
				{
					hsb->mg = mouse_pos.x - hsb->scrollbar->pos_x;
				}
				
				hsb->flags &= ~HSFi_CLICK0;
				hsb->flags |= HSFi_CLICK1;
			}
		}
		else
		{
			if(!(hsb->flags & HSFi_OVER))
			{
				hsb->flags &= ~HSFi_OVER;
			}
		}
		if ((!(hsb->flags & HSFi_CLICK0)) && ((hsb->flags & HSFi_CLICK1)))
		{
			hsb->scrollbar->pos_x = mouse_pos.x - hsb->mg;
			LBG_hscrollbar_execute(hsb,hsb->Scrolling);
			
			if (LBG_hscrollbar_get_maxwidth(hsb) - hsb->scrollbar->size_x) hsb->scrollamount = (hsb->scrollbar->pos_x - hsb->pos_x - hsb->button_left->size_x)*hsb->scrollmax/(LBG_hscrollbar_get_maxwidth(hsb) - hsb->scrollbar->size_x);
			else hsb->scrollamount = 0;
		}
		if ((!(hsb->flags & HSFi_CLICK0)) && (!(hsb->flags & HSFi_CLICK1)) && (key_pressed(280)))
		{
			hsb->flags |= HSFi_CLICK0;
			hsb->flags &= ~HSFi_CLICK1;
		}
		
	}
	
	
	
	if(hsb->target)
	switch(hsb->target->stype)
	{
		case 1:
		hsb->pos_x = hsb->target->cpos_x;
		hsb->pos_y = hsb->target->cpos_y + hsb->target->csize_y;
		hsb->size_x = hsb->target->csize_x;
		
		hsb->panel->pos_x = hsb->pos_x;
		hsb->panel->pos_y = hsb->pos_y;
		hsb->panel->size_x = hsb->size_x;
		
		hsb->button_right->pos_x = hsb->size_x - hsb->button_right->size_x;
		
		
		hsb->scrollbar->pos_x = hsb->pos_x + hsb->button_left->size_x;
		hsb->scrollbar->pos_y = hsb->pos_y;
		
		hsb->corner->pos_x = hsb->pos_x + hsb->size_x;
		hsb->corner->pos_y = hsb->pos_y;
		
		
		
		
		break;
	}
	
	
	LBG_hscrollbar_calc_barwidth(hsb);
	if(hsb->scrollbar->size_x != bmap_width(hsb->scrollbar->bmap))
	{
		ptr_remove(hsb->scrollbar->bmap);
		hsb->scrollbar->bmap = bmap_createblack(hsb->scrollbar->size_x,hsb->size_y,32);
		LBG_hscrollbar_bitmap(hsb->scrollbar->bmap,hsb->bmaps,hsb->scrollbar->size_x,hsb->size_y);
	}
	
	if((hsb->button_left->flags & BF_CLICKED) && LBG_mouse_over_object(hsb->button_left))
	{
		hsb->scrollamount -= hsb->buttonspeed*time_step;
		LBG_hscrollbar_execute(hsb,hsb->Scrolling);
	}
	if((hsb->button_right->flags & BF_CLICKED) && LBG_mouse_over_object(hsb->button_right))
	{
		hsb->scrollamount += hsb->buttonspeed*time_step;
		LBG_hscrollbar_execute(hsb,hsb->Scrolling);
	}
	
	if(LBG_hscrollbar_mouse_for_wheel(hsb) && (!target_vscroll) && LBG_not_disabled_by_disableflag(hsb)) hsb->scrollamount -= hsb->wheelspeed*mickey.z/12;
	if(LBG_hscrollbar_mouse_for_wheel(hsb) && (!target_vscroll) && LBG_not_disabled_by_disableflag(hsb) && hsb->wheelspeed*mickey.z) LBG_hscrollbar_execute(hsb,hsb->Scrolling);
	
	hsb->scrollamount = minv(hsb->scrollamount,hsb->scrollmax);
	hsb->scrollamount = maxv(hsb->scrollamount,0);
	if(hsb->scrollmax) hsb->scrollbar->pos_x += (LBG_hscrollbar_get_maxwidth(hsb)-hsb->scrollbar->size_x)*hsb->scrollamount/hsb->scrollmax;
	
	if(hsb->target) hsb->target->hscrollamount = hsb->scrollamount;
	
	
	
	
	
	
	
	
	if(hsb->flags & HSF_SHOW)
	{
		hsb->panel->flags |= SHOW;
		hsb->scrollbar->flags |= SHOW;
		hsb->corner->flags |= SHOW;
		hsb->button_left->flags |= BF_SHOW;
		hsb->button_right->flags |= BF_SHOW;
	}
	else
	{
		hsb->panel->flags &= ~SHOW;
		hsb->scrollbar->flags &= ~SHOW;
		hsb->corner->flags &= ~SHOW;
		hsb->button_left->flags &= ~BF_SHOW;
		hsb->button_right->flags &= ~BF_SHOW;
	}
	
	hsb->corner->flags &= ~SHOW;
	if((hsb->flags & HSF_SHOW) && (target_vscroll))
	hsb->corner->flags |= SHOW;
	
	if((hsb->flags & HSF_AUTODISABLED) || (!(hsb->target->flags & WF_HSCROLLBAR)))
	{
		hsb->panel->flags &= ~SHOW;
		hsb->scrollbar->flags &= ~SHOW;
		hsb->corner->flags &= ~SHOW;
		hsb->button_left->flags &= ~BF_SHOW;
		hsb->button_right->flags &= ~BF_SHOW;
	}
	
	
	
	
	return(hsb->next);
}



void LBG_hsbmaps_destroy_2frames (LBG_HSCROLLBAR_BMAPS* bmaps) // for internal use
{
	wait(2);
	free(bmaps);
}

LBG_HSCROLLBAR_BMAPS* LBG_hsbmaps (BMAP* bmap_left, BMAP* bmap_middle, BMAP* bmap_right, BMAP* bmap_bar, BMAP* bmap_corner)
{
	LBG_HSCROLLBAR_BMAPS* bmaps = malloc(sizeof(LBG_HSCROLLBAR_BMAPS));
	bmaps->bmap_left = bmap_left;
	bmaps->bmap_middle = bmap_middle;
	bmaps->bmap_right = bmap_right;
	bmaps->bmap_bar = bmap_bar;
	bmaps->bmap_corner = bmap_corner;
	LBG_pbmaps_destroy_2frames(bmaps);
	return(bmaps);
}



LBG_HSCROLLBAR* LBG_destroy_hscrollbar (LBG_HSCROLLBAR* hsb)
{
	LBG_hscrollbar_execute(hsb,hsb->Destroy);
	
	ptr_remove(hsb->panel);
	ptr_remove(hsb->scrollbar);
	ptr_remove(hsb->corner);
	LBG_destroy_button(hsb->button_left);
	LBG_destroy_button(hsb->button_right);
	
	LBG_object_destroy_infoboxes(hsb);
	LBG_object_destroy_rightclicks(hsb);
	
	LBG_HSCROLLBAR* next = hsb->next;
	if(hsb->previous) hsb->previous->next = hsb->next;
	else LBG_HSCROLLBAR_FIRST = hsb->next;
	if(hsb->next) hsb->next->previous = hsb->previous;
	
	free(hsb);
	LBG_object_make_handles_invalid(hsb);
	return(next);
}