void LBG_listbox_update_bmap (LBG_LISTBOX* lst, BMAP* bmap, LBG_LISTITEM_BMAPS* bmaps, int nr)
{
	BMAP* b;
	if(bmaps.bmap_left)
	{
		if((bmap != NULL) && (bmap != LBG_empty_bmap))
		{
			ptr_remove(bmap);
		}
		b = bmap_createblack(lst->lsize_x,lst->itemheight,32);
		switch(nr)
		{
			case 1: lst->bmap_default = b; break;
			case 2: lst->bmap_over = b; break;
			case 3: lst->bmap_marked = b; break;
		}
		
		LBG_progressbar_bitmap(b,bmaps,lst->lsize_x,lst->itemheight);
	}
	else
	{
		switch(nr)
		{
			case 1: lst->bmap_default = LBG_empty_bmap; break;
			case 2: lst->bmap_over = LBG_empty_bmap; break;
			case 3: lst->bmap_marked = LBG_empty_bmap; break;
		}
	}
}

void LBG_listbox_update_bmaps (LBG_LISTBOX* lst)
{
	LBG_listbox_update_bmap (lst,lst->bmap_default,lst->bmaps_default,1);
	LBG_listbox_update_bmap (lst,lst->bmap_over,lst->bmaps_over,2);
	LBG_listbox_update_bmap (lst,lst->bmap_marked,lst->bmaps_marked,3);
}

LBG_LISTBOX* LBG_create_listbox (LBG_WINDOW* _parent, var pos_x, var pos_y, var size_x, var size_y, var ipos_x, var ipos_y, var isize_x, var isize_y, LBG_LISTBOX_BMAPS* bmaps, long flags)
{
	LBG_LISTBOX* lst = malloc(sizeof(LBG_LISTBOX));
	lst->ssize = sizeof(LBG_LISTBOX);
	lst->stype = 13;
	
	
	
	lst->parent = _parent;
	lst->layer = 0;
	lst->flags = flags;
	
	
	
	lst->pos_x = pos_x;
	lst->pos_y = pos_y;
	
	lst->scale_x = 1;
	lst->scale_y = 1;
	
	
	lst->ipos_x = ipos_x;
	lst->ipos_y = ipos_y;
	lst->isize_x = isize_x;
	lst->isize_y = isize_y;
	
	lst->lpos_x = lst->pos_x + lst->ipos_x;
	lst->lpos_y = lst->pos_y + lst->ipos_y;
	lst->lsize_x = lst->isize_x;
	lst->lsize_y = lst->isize_y;
	
	
	
	lst->panel = pan_create("",LBG_object_calc_panel_layer(lst));
	lst->bmaps.bmap_topleft = bmaps->bmap_topleft;
	lst->bmaps.bmap_top = bmaps->bmap_top;
	lst->bmaps.bmap_topright = bmaps->bmap_topright;
	lst->bmaps.bmap_left = bmaps->bmap_left;
	lst->bmaps.bmap_right = bmaps->bmap_right;
	lst->bmaps.bmap_bottomleft = bmaps->bmap_bottomleft;
	lst->bmaps.bmap_bottom = bmaps->bmap_bottom;
	lst->bmaps.bmap_bottomright = bmaps->bmap_bottomright;
	lst->bmaps.bmap_center = bmaps->bmap_center;
	
	
	lst->size_x = size_x;
	lst->size_y = size_y;
	
	
	lst->panel->bmap = bmap_createblack(lst->size_x,lst->size_y,32);
	LBG_window_content_bitmap(lst->panel->bmap,bmaps,lst->size_x,lst->size_y);
	lst->panel->pos_x = lst->pos_x;
	lst->panel->pos_y = lst->pos_y;
	lst->panel->size_x = lst->size_x;
	lst->panel->size_y = lst->size_y;
	
	
	if(lst->flags & LF_SHOW)
	{
		lst->panel->flags |= SHOW;
	}
	
	
	memset(&(lst->bmaps_default),0,sizeof(LBG_LISTITEM_BMAPS));
	memset(&(lst->bmaps_over),0,sizeof(LBG_LISTITEM_BMAPS));
	memset(&(lst->bmaps_marked),0,sizeof(LBG_LISTITEM_BMAPS));
	lst->bmaps_default.bmap_left = NULL;
	lst->bmaps_over.bmap_left = NULL;
	lst->bmaps_marked.bmap_left = NULL;
	
	lst->bmap_default = LBG_empty_bmap;
	lst->bmap_over = LBG_empty_bmap;
	lst->bmap_marked = LBG_empty_bmap;
	
	lst->item_first = NULL;
	
	
	lst->font = 0;
	
	lst->tpos_x = 0;
	lst->tpos_y = 0;
	
	if(LBG_listitem_font) lst->itemheight = LBG_listitem_font.dy;
	else lst->itemheight = 32;
	
	lst->color_default.red = 255;
	lst->color_default.green = 255;
	lst->color_default.blue = 255;
	lst->color_over.red = 255;
	lst->color_over.green = 255;
	lst->color_over.blue = 255;
	lst->color_marked.red = 255;
	lst->color_marked.green = 255;
	lst->color_marked.blue = 255;
	
	
	
	lst->vscrollamount = 0;
	lst->marked_item = NULL;
	
	lst->next = NULL;
	if(LBG_LISTBOX_FIRST == NULL)
	{
		LBG_LISTBOX_FIRST = lst;
		lst->previous = NULL;
	}
	else
	{
		lst->previous = LBG_object_last(LBG_LISTBOX_FIRST);
		lst->previous->next = lst;
	}
	
	
	LBG_object_upate_size (lst);
	
	LBG_listbox_update_bmaps(lst);
	
	lst->Destroy = 0;
	lst->Select = 0;
	
	return (lst);
}





LBG_LISTITEM* LBG_create_listitem (LBG_LISTBOX* _parent, var position, STRING* caption, long flags)
{
	LBG_LISTITEM* itm = malloc(sizeof(LBG_LISTITEM));
	itm->ssize = sizeof(LBG_LISTITEM);
	itm->stype = 14;
	
	
	
	if(flags & LIF_EXTERNSTRING)
	{
		itm->caption = caption;
	}
	else
	{
		itm->caption = str_create("");
		str_cpy(itm->caption,caption);
	}
	
	itm->parent = _parent;
	itm->layer = 0;
	itm->flags = flags;
	
	
	
	itm->text = txt_create(1,LBG_object_calc_text_layer(itm));
	ptr_remove((itm->text->pstring)[0]);
	(itm->text->pstring)[0] = itm->caption;
	
	if(((LBG_LISTBOX*)(itm->parent))->font != NULL) itm->text->font = ((LBG_LISTBOX*)(itm->parent))->font;
	else itm->text->font = LBG_listitem_font;
	
	vec_set(itm->text->blue,((LBG_LISTBOX*)(itm->parent))->color_default);
	
	
	
	
	itm->scale_x = 1;
	itm->scale_y = 1;
	
	
	
	
	itm->panel = pan_create("",LBG_object_calc_panel_layer(itm));
	
	
	
	itm->size_x = ((LBG_LISTBOX*)(itm->parent))->lsize_x;
	itm->size_y = ((LBG_LISTBOX*)(itm->parent))->lsize_y;
	
	
	
	
	itm->panel->bmap = LBG_empty_bmap;
	
	
	itm->panel->pos_x = itm->pos_x;
	itm->panel->pos_y = itm->pos_y;
	itm->panel->size_x = itm->size_x;
	itm->panel->size_y = itm->size_y;
	
	
	if(itm->flags & LIF_SHOW)
	{
		itm->panel->flags |= SHOW;
		itm->text->flags |= SHOW;
	}
	
	
	
	
	
	itm->next = NULL;
	if(((LBG_LISTBOX*)(itm->parent))->item_first == NULL)
	{
		((LBG_LISTBOX*)(itm->parent))->item_first = itm;
		itm->previous = NULL;
	}
	else
	{
		if(position >= LBG_object_num(((LBG_LISTBOX*)(itm->parent))->item_first))
		{
			itm->previous = LBG_object_last(((LBG_LISTBOX*)(itm->parent))->item_first);
			itm->previous->next = itm;
		}
		else
		{
			itm->next = LBG_object_nr(((LBG_LISTBOX*)(itm->parent))->item_first,position);
			if(itm->next == ((LBG_LISTBOX*)(itm->parent))->item_first) ((LBG_LISTBOX*)(itm->parent))->item_first = itm;
			itm->previous = itm->next->previous;
			if(itm->previous) itm->previous->next = itm;
			itm->next->previous = itm;
		}
	}
	
	
	LBG_object_upate_size (itm);
	
	itm->Destroy = 0;
	itm->Select = 0;
	itm->Unselect = 0;
	
	
	return (itm);
}









void LBG_update_listitem_layer (LBG_LISTITEM* itm)
{
	var x;
	x = itm->parent->panel->layer+1;
	if(itm->panel->layer != x) layer_sort(itm->panel,x);
	x = itm->parent->panel->layer+2;
	if(itm->text->layer != x) layer_sort(itm->text,x);
}

void LBG_listbox_unmark_all_listitems (LBG_LISTBOX* lst)
{
	LBG_LISTITEM* itm = lst->item_first;
	while(itm)
	{
		itm->flags &= ~LIF_MARKED;
	}
}


void LBG_listbox_execute (LBG_LISTBOX* lst, void* func)
{
	if(func != 0)
	{
		LBG_event_object = lst;
		LBG_event_listbox = lst;
		LBG_event = func;
		LBG_event();
	}
}
void LBG_listitem_execute (LBG_LISTITEM* itm, void* func)
{
	if(func != 0)
	{
		LBG_event_object = itm;
		LBG_event_listbox = itm->parent;
		LBG_event_listitem = itm;
		LBG_event = func;
		LBG_event();
	}
}


var LBG_listbox_num_marked (LBG_LISTBOX* lst)
{
	if(!lst) return (0);
	LBG_LISTITEM* itm = lst->item_first;
	var i = 0;
	while(itm)
	{
		if(itm->flags & LIF_MARKED) i++;
		itm = itm->next;
	}
	return(i);
}


LBG_EDITBOX* LBG_update_editbox (LBG_EDITBOX* ebx);
void LBG_mark_listitem (LBG_LISTITEM* itm)
{
	int x;
	itm->flags |= LIF_EVENT;
	
	if((itm->flags & LIF_MARKED) && (itm->parent->flags & LF_UNSELECT) && (key_ctrl || key_shift || (LBG_listbox_num_marked(itm->parent) <= 1)))
	{
		itm->flags &= ~LIF_MARKED;
		if(((LBG_LISTBOX*)(itm->parent))->marked_item == itm) ((LBG_LISTBOX*)(itm->parent))->marked_item = NULL;
		LBG_listitem_execute(itm,itm->Unselect);
	}
	else
	{
		
		itm->flags |= LIF_MARKED;
		((LBG_LISTBOX*)(itm->parent))->marked_item = itm;
		if((itm->parent->flags & LFi_RIGHTCLICK) || (itm->parent->flags & LFi_COMBOBOX))
		{
			itm->parent->flags &= ~LF_SHOW;
			itm->parent->flags |= LF_DISABLED;
			if(itm->parent->flags & LFi_RIGHTCLICK)
			{
				itm->parent->parent->flags |= RFi_CLICK0;
				itm->parent->parent->flags &= ~RFi_CLICK1;
				itm->parent->parent->flags &= ~RF_CLICKED;
				itm->parent->parent->flags &= ~RF_ACTIVE;
			}
			if(itm->parent->flags & LFi_COMBOBOX)
			{
				str_cpy(((LBG_COMBOBOX*)(itm->parent->parent))->caption,itm->caption);
				LBG_update_editbox(((LBG_COMBOBOX*)(itm->parent->parent))->editbox);
				((LBG_COMBOBOX*)(itm->parent->parent))->chosen_option = itm;
			}
		}
	}
	
	LBG_listitem_execute(itm,itm->Select);
	LBG_listbox_execute(itm->parent,((LBG_LISTBOX*)(itm->parent))->Select);
	LBG_LISTITEM* itm1 = ((LBG_LISTBOX*)(itm->parent))->item_first;
	if (!((itm->parent->flags & LF_MULTIPLE) && (key_ctrl || key_shift)))
	while(itm1)
	{
		if ((itm1 != itm) || (itm->parent->flags & LFi_RIGHTCLICK) || (itm->parent->flags & LFi_COMBOBOX))
		{
			x = itm1->flags & LIF_MARKED;
			itm1->flags &= ~LIF_MARKED;
			if(x) LBG_listitem_execute(itm1,itm1->Unselect);
		}
		itm1 = itm1->next;
	}
}

void LBG_listitem_event (LBG_LISTITEM* itm)
{
	
	itm->flags &= ~LIF_EVENT;
	if(!key_pressed(280)) return;
	LBG_HANDLE* h = LBG_get_eventhandle(itm);
	wait(1);
	if(!h->valid)
	{
		LBG_destroy_handle(h);
		return;
	}
	if(!key_pressed(280))
	{
		
		
		LBG_mark_listitem(itm);
		
		
		wait(1);
		if(!h->valid)
		{
			LBG_destroy_handle(h);
			return;
		}
		itm->flags &= ~LIF_EVENT;
	}
}

int LBG_mouse_over_listbox_larea (LBG_LISTBOX* lst)
{
	return ((mouse_pos.x >= lst->lpos_x) && (mouse_pos.x < lst->lpos_x + lst->lsize_x) && (mouse_pos.y >= lst->lpos_y) && (mouse_pos.y < lst->lpos_y + lst->lsize_y) && (mouse_pos.x < lst->panel->pos_x + lst->size_x - lst->vscroll_width));
}

LBG_LISTITEM* LBG_manage_listitem (LBG_LISTITEM* itm)
{
	itm->size_y = ((LBG_LISTBOX*)(itm->parent))->itemheight;
	
	LBG_object_upate_pos(itm);
	LBG_object_upate_size(itm);
	LBG_update_listitem_layer(itm);
	
	if(itm->flags & LIF_MARKED) vec_set(itm->text->blue,((LBG_LISTBOX*)(itm->parent))->color_marked);
	else vec_set(itm->text->blue,((LBG_LISTBOX*)(itm->parent))->color_default);
	
	if (!(itm->parent->flags & LF_DISABLED))
	{
		if (!(key_pressed(280)))
		{
			itm->flags &= ~LIFi_CLICK0;
			itm->flags &= ~LIFi_CLICK1;
			itm->flags &= ~LIF_CLICKED;
		}
		
		if (LBG_not_disabled_by_disableflag(itm) && LBG_mouse_over_object(itm) && LBG_mouse_over_object(itm->parent) && LBG_mouse_over_listbox_larea(itm->parent) && ((itm->parent == LBG_mouse_window()) || (itm->parent->parent == LBG_mouse_window())) && (LBG_window_mouse_over_content (itm->parent->parent) || (itm->parent->flags & LFi_RIGHTCLICK) || (itm->parent->flags & LFi_COMBOBOX)) && (((!(itm->flags & LIFi_CLICK0)) && (!(itm->flags & LIFi_CLICK1))) || ((!(itm->flags & LIFi_CLICK0)) && ((itm->flags & LIFi_CLICK1)))))
		{
			itm->flags |= LIFi_OVER;
			
			if(itm->flags & LIF_MARKED) itm->panel.bmap = ((LBG_LISTBOX*)(itm->parent))->bmap_marked;
			else itm->panel.bmap = ((LBG_LISTBOX*)(itm->parent))->bmap_over;
			vec_set(itm->text->blue,((LBG_LISTBOX*)(itm->parent))->color_over);
			if (key_pressed(280))
			{
				itm->flags &= ~LIFi_CLICK0;
				itm->flags |= LIFi_CLICK1;
				itm->flags |= LIF_CLICKED;
				itm->panel.bmap = ((LBG_LISTBOX*)(itm->parent))->bmap_marked;
				vec_set(itm->text->blue,((LBG_LISTBOX*)(itm->parent))->color_marked);
				LBG_listitem_event(itm);
			}
		}
		else
		{
			
			if(itm->flags & LIF_MARKED) itm->panel.bmap = ((LBG_LISTBOX*)(itm->parent))->bmap_marked;
			else itm->panel.bmap = ((LBG_LISTBOX*)(itm->parent))->bmap_default;
			if(!(itm->flags & LIFi_OVER))
			{
				itm->flags &= ~LIFi_OVER;
				itm->flags &= ~LIF_CLICKED;
			}
			itm->flags &= ~LIF_EVENT;
		}
		if ((!(itm->flags & LIFi_CLICK0)) && (!(itm->flags & LIFi_CLICK1)) && (key_pressed(280)))
		{
			itm->flags |= LIFi_CLICK0;
			itm->flags &= ~LIFi_CLICK1;
			itm->flags &= ~LIF_CLICKED;
		}
		
	}
	else
	{
		itm->flags |= LIFi_CLICK0;
		itm->flags &= ~LIFi_CLICK1;
		itm->flags &= ~LIFi_OVER;
		itm->flags &= ~LIF_CLICKED;
	}
	
	
	if(itm->parent->flags & LF_SHOW)
	{
		itm->panel->flags |= SHOW;
		itm->text->flags |= SHOW;
	}
	else
	{
		itm->panel->flags &= ~SHOW;
		itm->text->flags &= ~SHOW;
	}
	
	
	return itm->next;
}

void LBG_update_listbox_layer (LBG_LISTBOX* lst)
{
	if(lst->parent)
	if((lst->parent->stype == 15) || (lst->parent->stype == 16))
	{
		var x;
		x = LBG_highest_layer-5;
		if(lst->panel->layer != x) layer_sort(lst->panel,x);
		return;
	}
	
	var x;
	x = LBG_object_calc_panel_layer(lst);
	if(lst->panel->layer != x) layer_sort(lst->panel,x);
}

void LBG_listbox_calc_vscroll_width (LBG_LISTBOX* lst)
{
	lst->vscroll_width = 0;
	if(!(lst->flags & LF_VSCROLLBAR)) return;
	
	LBG_VSCROLLBAR* vsb = LBG_VSCROLLBAR_FIRST;
	vsb = LBG_VSCROLLBAR_FIRST;
	while(vsb)
	{
		if(vsb->target == lst)
		{
			lst->vscroll_width = vsb->size_x;
			return;
		}
		vsb = vsb->next;
	}
}


void LBG_listbox_update_ilpossize (LBG_LISTBOX* lst)
{
	LBG_listbox_calc_vscroll_width(lst);
	lst->lpos_x = lst->panel->pos_x + lst->ipos_x;
	lst->lpos_y = lst->panel->pos_y + lst->ipos_y;
	lst->lsize_x = lst->isize_x;
	lst->lsize_y = lst->isize_y;
}

var LBG_listbox_get_number_of_items(LBG_LISTBOX* lst)
{
	var ret = 0;
	LBG_LISTITEM* itm = lst->item_first;
	while(itm)
	{
		itm = itm->next;
		ret++;
	}
	return(ret);
}

LBG_LISTBOX* LBG_manage_listbox (LBG_LISTBOX* lst)
{
	LBG_object_upate_pos(lst);
	LBG_object_upate_size(lst);
	LBG_update_listbox_layer(lst);
	
	LBG_listbox_update_ilpossize(lst);
	
	
	
	var y = lst->lpos_y - integer(lst->vscrollamount+0.5)*lst->itemheight;
	LBG_LISTITEM* itm = lst->item_first;
	while(itm)
	{
		itm->pos_x = lst->lpos_x;
		itm->pos_y = y;
		itm = LBG_manage_listitem(itm);
		y += lst->itemheight;
	}
	if(lst->flags & LF_AUTOVSCROLL)
	{
		if(LBG_listbox_get_number_of_items(lst)*lst->itemheight > lst->lsize_y) lst->flags |= LF_VSCROLLBAR;
		else lst->flags &= ~LF_VSCROLLBAR;
	}
	
	if(lst->flags & LF_SHOW)
	{
		lst->panel->flags |= SHOW;
	}
	else
	{
		lst->panel->flags &= ~SHOW;
	}
	
	
	return lst->next;
}




var LBG_listbox_get_vscrollmax (LBG_LISTBOX* lst)
{
	return(LBG_listbox_get_number_of_items(lst)-integer(lst->lsize_y/lst->itemheight));
}

void LBG_update_listbox (LBG_LISTBOX* lst)
{
	LBG_object_upate_pos(lst);
	LBG_object_upate_size(lst);
	LBG_update_listbox_layer(lst);
	LBG_listbox_update_ilpossize(lst);
	LBG_listbox_update_bmaps(lst);
	
	
	
	LBG_VSCROLLBAR* vsb = LBG_VSCROLLBAR_FIRST;
	while(vsb)
	{
		if(vsb->target == lst) vsb->scrollmax = LBG_listbox_get_vscrollmax(lst);
		vsb = vsb->next;
	}
	
	
	ptr_remove(lst->panel->bmap);
	lst->panel->bmap = bmap_createblack(lst->size_x,lst->size_y,32);
	LBG_window_content_bitmap(lst->panel->bmap,lst->bmaps,lst->size_x,lst->size_y);
	lst->panel->size_x = lst->size_x;
	lst->panel->size_y = lst->size_y;
}


LBG_LISTITEM* LBG_destroy_listitem (LBG_LISTITEM* itm)
{
	LBG_listitem_execute(itm,itm->Destroy);
	
	if(itm->parent->flags & LFi_COMBOBOX)
	{
		if(((LBG_COMBOBOX*)(itm->parent->parent))->chosen_option == itm) ((LBG_COMBOBOX*)(itm->parent->parent))->chosen_option = NULL;
	}
	if(((LBG_LISTBOX*)(itm->parent))->marked_item == itm) ((LBG_LISTBOX*)(itm->parent))->marked_item = NULL;
	
	if(!(itm->flags & LIF_EXTERNSTRING)) ptr_remove(itm->caption);
	ptr_remove(itm->text);
	ptr_remove(itm->panel);
	
	LBG_object_destroy_infoboxes(itm);
	LBG_object_destroy_rightclicks(itm);
	
	
	LBG_LISTITEM* next = itm->next;
	if(itm->previous) itm->previous->next = itm->next;
	else ((LBG_LISTBOX*)(itm->parent))->item_first = itm->next;
	if(itm->next) itm->next->previous = itm->previous;
	
	free(itm);
	LBG_object_make_handles_invalid(itm);
	return(next);
}





LBG_LISTBOX* LBG_destroy_listbox (LBG_LISTBOX* lst)
{
	LBG_listbox_execute(lst,lst->Destroy);
	ptr_remove(lst->panel);
	
	LBG_LISTITEM* itm = lst->item_first;
	while(itm)
	{
		itm = LBG_destroy_listitem(itm);
	}
	
	
	LBG_VSCROLLBAR* vsb = LBG_VSCROLLBAR_FIRST;
	vsb = LBG_VSCROLLBAR_FIRST;
	while(vsb)
	{
		if(vsb->target == lst)
		{
			vsb = LBG_destroy_vscrollbar (vsb);
		}
		else vsb = vsb->next;
	}
	
	LBG_object_destroy_infoboxes(lst);
	LBG_object_destroy_rightclicks(lst);
	
	
	LBG_LISTBOX* next = lst->next;
	if(lst->previous) lst->previous->next = lst->next;
	else LBG_LISTBOX_FIRST = lst->next;
	if(lst->next) lst->next->previous = lst->previous;
	
	free(lst);
	LBG_object_make_handles_invalid(lst);
	return(next);
}




void LBG_listbox_calc_size_y (LBG_LISTBOX* lst) // if it's part of a rightclick menu or a combobox
{
	lst->size_y = lst->ipos_y*2;
	LBG_LISTITEM* itm = lst->item_first;
	while(itm)
	{
		lst->size_y += lst->itemheight;
		itm = itm->next;
	}
}





void LBG_lbmaps_destroy_2frames (LBG_LISTBOX_BMAPS* bmaps) // for internal use
{
	wait(2);
	free(bmaps);
}

LBG_LISTBOX_BMAPS* LBG_lbmaps (BMAP* bmap_topleft, BMAP* bmap_top, BMAP* bmap_topright, BMAP* bmap_left,
BMAP* bmap_right, BMAP* bmap_bottomleft, BMAP* bmap_bottom, BMAP* bmap_bottomright, BMAP* bmap_center)
{
	LBG_LISTBOX_BMAPS* bmaps = malloc(sizeof(LBG_LISTBOX_BMAPS));
	bmaps->bmap_topleft = bmap_topleft;
	bmaps->bmap_top = bmap_top;
	bmaps->bmap_topright = bmap_topright;
	bmaps->bmap_left = bmap_left;
	bmaps->bmap_right = bmap_right;
	bmaps->bmap_bottomleft = bmap_bottomleft;
	bmaps->bmap_bottom = bmap_bottom;
	bmaps->bmap_bottomright = bmap_bottomright;
	bmaps->bmap_center = bmap_center;
	LBG_lbmaps_destroy_2frames(bmaps);
	return(bmaps);
}




