

void LBG_progressbar_bitmap (BMAP* _bmap, LBG_PROGRESSBAR_BMAPS* bmaps, var size_x, var size_y) // For internal use
{
	bmap_blit(_bmap,bmaps->bmap_pan_left,vector(0,0,0),NULL);
	bmap_blit(_bmap,bmaps->bmap_pan_right,vector(size_x-bmap_width(bmaps->bmap_pan_right),0,0),NULL);
	bmap_blit(_bmap,bmaps->bmap_pan_middle,vector(bmap_width(bmaps->bmap_pan_left),0,0),vector(size_x-bmap_width(bmaps->bmap_pan_left)-bmap_width(bmaps->bmap_pan_right),bmap_height(bmaps->bmap_pan_middle),0));
}




LBG_PROGRESSBAR* LBG_create_progressbar (LBG_WINDOW* _parent, var pos_x, var pos_y, var width, var barpos_x, var barpos_y, var tpos_x, var tpos_y, STRING* format, LBG_PROGRESSBAR_BMAPS* bmaps, long flags, var maximum, var progress)
{
	LBG_PROGRESSBAR* prg = malloc(sizeof(LBG_PROGRESSBAR));
	prg->ssize = sizeof(LBG_PROGRESSBAR);
	prg->stype = 8;
	
	if(flags & PBF_EXTERNFORMAT)
	{
		prg->format = format;
	}
	else
	{
		prg->format = str_create("");
		str_cpy(prg->format,format);
	}
	prg->caption = str_create("");
	
	
	prg->parent = _parent;
	prg->layer = 0;
	prg->flags = flags;
	
	prg->text = txt_create(1,LBG_object_calc_text_layer(prg));
	ptr_remove((prg->text->pstring)[0]);
	(prg->text->pstring)[0] = prg->caption;
	
	prg->text->font = LBG_progressbar_font;
	
	prg->tpos_x = tpos_x;
	prg->tpos_y = tpos_y;
	
	
	prg->pos_x = pos_x;
	prg->pos_y = pos_y;
	
	prg->scale_x = 1;
	prg->scale_y = 1;
	
	prg->panel = pan_create("",LBG_object_calc_panel_layer(prg));
	prg->bmap_pan_left = bmaps->bmap_pan_left;
	prg->bmap_pan_middle = bmaps->bmap_pan_middle;
	prg->bmap_pan_right = bmaps->bmap_pan_right;
	prg->bmap_bar = bmaps->bmap_bar;
	
	
	prg->size_x = width;
	prg->size_y = bmap_height(prg->bmap_pan_left);
	
	
	prg->panel->bmap = bmap_createblack(prg->size_x,prg->size_y,32);
	LBG_progressbar_bitmap(prg->panel->bmap,bmaps,prg->size_x,prg->size_y);
	prg->panel->pos_x = prg->pos_x;
	prg->panel->pos_y = prg->pos_y;
	prg->panel->size_x = prg->size_x;
	prg->panel->size_y = prg->size_y;
	
	prg->text->pos_x = prg->pos_x + prg->tpos_x;
	prg->text->pos_y = prg->pos_y + prg->tpos_y;
	
	prg->bar = pan_create("",LBG_object_calc_panel_layer(prg)+1);
	prg->bar->bmap = prg->bmap_bar;
	
	if(prg->flags & PBF_SHOW)
	{
		prg->panel->flags |= SHOW;
		prg->bar->flags |= SHOW;
		prg->text->flags |= SHOW;
	}
	
	
	
	
	
	prg->next = NULL;
	if(LBG_PROGRESSBAR_FIRST == NULL)
	{
		LBG_PROGRESSBAR_FIRST = prg;
		prg->previous = NULL;
	}
	else
	{
		prg->previous = LBG_object_last(LBG_PROGRESSBAR_FIRST);
		prg->previous->next = prg;
	}
	
	
	LBG_object_upate_size (prg);
	
	
	prg->maximum = maximum;
	prg->progress = progress;
	
	prg->barpos_x = barpos_x;
	prg->barpos_y = barpos_y;
	
	prg->bar_width = prg->size_x - prg->barpos_x*2;
	
	
	prg->Destroy = 0;
	
	return (prg);
}


void LBG_update_progressbar_layer (LBG_PROGRESSBAR* prg)
{
	var x;
	x = LBG_object_calc_panel_layer(prg);
	if(prg->panel->layer != x) layer_sort(prg->panel,x);
	x = LBG_object_calc_panel_layer(prg)+1;
	if(prg->bar->layer != x) layer_sort(prg->bar,x);
	x = LBG_object_calc_text_layer(prg);
	if(prg->text->layer != x) layer_sort(prg->text,x);
}

void LBG_update_progressbar_string (LBG_PROGRESSBAR* prg)
{
	str_printf(prg->caption, prg->format,(double)prg->progress);
}



LBG_PROGRESSBAR* LBG_manage_progressbar (LBG_PROGRESSBAR* prg)
{
	LBG_object_upate_pos(prg);
	LBG_object_upate_size(prg);
	LBG_update_progressbar_layer(prg);
	
	if(!(prg->flags & PBF_SCALE))
	{
		prg->bar->size_x = prg->bar_width*prg->progress/prg->maximum;
		prg->bar->size_y = bmap_height(prg->bar->bmap);
		
		if(prg->parent)
		{
			prg->bar->size_x = maxv(0.1,minv(prg->bar->size_x,prg->parent->cpos_x+prg->parent->csize_x-prg->bar->pos_x)+0.1);
			prg->bar->size_y = maxv(0.1,minv(prg->bar->size_y,prg->parent->cpos_y+prg->parent->csize_y-prg->bar->pos_y)+0.1);
		}
		else
		{
			prg->bar->size_x += 0.1;
			prg->bar->size_y += 0.1;
		}
	}
	else
	{
		prg->bar->size_x = bmap_width(prg->bar->bmap);
		prg->bar->size_y = bmap_height(prg->bar->bmap);
		if(prg->maximum && prg->bar->size_x) prg->bar->scale_x = prg->bar_width*prg->progress/prg->maximum/prg->bar->size_x;
		if(prg->parent)
		{
			if(prg->progress > 0)
			{
				if(prg->bar->scale_x) prg->bar->size_x = maxv(0.1,minv(prg->bar->size_x,(prg->parent->cpos_x+prg->parent->csize_x-prg->bar->pos_x)/prg->bar->scale_x)+0.1);
			}
			else prg->bar->size_x = 0.1;
			prg->bar->size_y = maxv(0.1,minv(prg->bar->size_y,prg->parent->cpos_y+prg->parent->csize_y-prg->bar->pos_y)+0.1);
		}
		else if(!prg->bar->scale_x) prg->bar->size_x = 0.1;
	}
	if((prg->bar->size_x < 0.5) || (prg->bar->scale_x < 0.003)) prg->bar->size_x = 0.1;
	if(prg->parent) if ((prg->panel->pos_x < prg->parent->cpos_x) || (prg->panel->pos_y < prg->parent->cpos_y)) prg->bar->size_x = 0.1;
	LBG_update_progressbar_string(prg);
	
	if(prg->flags & PBF_SHOW)
	{
		prg->panel->flags |= SHOW;
		prg->text->flags |= SHOW;
		prg->bar->flags |= SHOW;
	}
	else
	{
		prg->panel->flags &= ~SHOW;
		prg->text->flags &= ~SHOW;
		prg->bar->flags &= ~SHOW;
	}
	return prg->next;
}







void LBG_pbmaps_destroy_2frames (LBG_PROGRESSBAR_BMAPS* bmaps) // for internal use
{
	wait(2);
	free(bmaps);
}

LBG_PROGRESSBAR_BMAPS* LBG_pbmaps (BMAP* bmap_pan_left, BMAP* bmap_pan_middle, BMAP* bmap_pan_right, BMAP* bmap_bar)
{
	LBG_PROGRESSBAR_BMAPS* bmaps = malloc(sizeof(LBG_PROGRESSBAR_BMAPS));
	bmaps->bmap_pan_left = bmap_pan_left;
	bmaps->bmap_pan_middle = bmap_pan_middle;
	bmaps->bmap_pan_right = bmap_pan_right;
	bmaps->bmap_bar = bmap_bar;
	LBG_pbmaps_destroy_2frames(bmaps);
	return(bmaps);
}


void LBG_progressbar_execute (LBG_PROGRESSBAR* prg, void* func)
{
	if(func != 0)
	{
		LBG_event_object = prg;
		LBG_event_progressbar = prg;
		LBG_event = func;
		LBG_event();
	}
}


LBG_PROGRESSBAR* LBG_destroy_progressbar (LBG_PROGRESSBAR* prg)
{
	LBG_progressbar_execute(prg,prg->Destroy);
	if(!(prg->flags & PBF_EXTERNFORMAT)) ptr_remove(prg->format);
	ptr_remove(prg->caption);
	ptr_remove(prg->text);
	ptr_remove(prg->panel);
	ptr_remove(prg->bar);
	
	LBG_object_destroy_infoboxes(prg);
	LBG_object_destroy_rightclicks(prg);
	
	LBG_PROGRESSBAR* next = prg->next;
	if(prg->previous) prg->previous->next = prg->next;
	else LBG_PROGRESSBAR_FIRST = prg->next;
	if(prg->next) prg->next->previous = prg->previous;
	
	free(prg);
	LBG_object_make_handles_invalid(prg);
	return(next);
}


void LBG_update_progressbar(LBG_PROGRESSBAR* prg)
{
	LBG_object_upate_pos(prg);
	LBG_object_upate_size(prg);
	LBG_update_progressbar_layer(prg);
	ptr_remove(prg->panel->bmap);
	prg->panel->bmap = bmap_createblack(prg->size_x,prg->size_y,32);
	LBG_progressbar_bitmap(prg->panel->bmap,&(prg->bmap_pan_left),prg->size_x,prg->size_y);
}