LBG_SLIDER* LBG_create_slider (LBG_WINDOW* _parent, var pos_x, var pos_y, var width, LBG_SLIDER_BMAPS* bmaps, var minimum, var maximum, var value, long flags)
{
	LBG_SLIDER* sli = malloc(sizeof(LBG_SLIDER));
	sli->ssize = sizeof(LBG_SLIDER);
	sli->stype = 11;
	
	
	
	sli->parent = _parent;
	sli->layer = 0;
	sli->flags = flags;
	
	
	
	sli->pos_x = pos_x;
	sli->pos_y = pos_y;
	
	sli->scale_x = 1;
	sli->scale_y = 1;
	
	
	if(flags & SF_EXTERNVAR)
	{
		sli->value = *((var*)value);
		sli->v = value;
	}
	else
	{
		sli->value = value;
		sli->v = NULL;
	}
	
	sli->maximum = maximum;
	sli->minimum = minimum;
	
	sli->panel = pan_create("",LBG_object_calc_panel_layer(sli));
	sli->bmaps.bmap_left = bmaps->bmap_left;
	sli->bmaps.bmap_middle = bmaps->bmap_middle;
	sli->bmaps.bmap_right = bmaps->bmap_right;
	sli->bmaps.bmap_knob_default = bmaps->bmap_knob_default;
	sli->bmaps.bmap_knob_over = bmaps->bmap_knob_over;
	sli->bmaps.bmap_knob_clicked = bmaps->bmap_knob_clicked;
	
	
	sli->size_x = width;
	sli->size_y = bmap_height(sli->bmaps.bmap_left);
	
	
	sli->panel->bmap = bmap_createblack(sli->size_x,sli->size_y,32);
	LBG_progressbar_bitmap(sli->panel->bmap,bmaps,sli->size_x,sli->size_y);
	sli->panel->pos_x = sli->pos_x;
	sli->panel->pos_y = sli->pos_y;
	sli->panel->size_x = sli->size_x;
	sli->panel->size_y = sli->size_y;
	
	
	sli->knob = pan_create("",LBG_object_calc_panel_layer(sli)+1);
	sli->knob->bmap = sli->bmaps.bmap_knob_default;
	sli->knob->size_x = bmap_width(sli->bmaps.bmap_knob_default);
	sli->knob->size_y = bmap_height(sli->bmaps.bmap_knob_default);
	
	if(sli->flags & SF_SHOW)
	{
		sli->panel->flags |= SHOW;
		sli->knob->flags |= SHOW;
	}
	
	
	
	
	sli->next = NULL;
	if(LBG_SLIDER_FIRST == NULL)
	{
		LBG_SLIDER_FIRST = sli;
		sli->previous = NULL;
	}
	else
	{
		sli->previous = LBG_object_last(LBG_SLIDER_FIRST);
		sli->previous->next = sli;
	}
	
	
	sli->Destroy = 0;
	sli->Sliding = 0;
	
	LBG_object_upate_size (sli);
	
	
	return (sli);
}




void LBG_update_slider_layer (LBG_SLIDER* sli)
{
	var x;
	x = LBG_object_calc_panel_layer(sli);
	if(sli->panel->layer != x) layer_sort(sli->panel,x);
	x = LBG_object_calc_panel_layer(sli)+1;
	if(sli->knob->layer != x) layer_sort(sli->knob,x);
}


void LBG_slider_execute (LBG_SLIDER* sli, void* func)
{
	if(func != 0)
	{
		LBG_event_object = sli;
		LBG_event_slider = sli;
		LBG_event = func;
		LBG_event();
	}
}

LBG_SLIDER* LBG_manage_slider (LBG_SLIDER* sli)
{
	LBG_object_upate_pos(sli);
	LBG_object_upate_size(sli);
	LBG_update_slider_layer(sli);
	
	
	
	
	if(sli->flags & SF_EXTERNVAR) sli->value = *(sli->v);
	
	
	if(!(sli->flags & SF_DISABLED))
	{
		
		if (!(key_pressed(280)))
		{
			sli->flags &= ~SFi_CLICK0;
			sli->flags &= ~SFi_CLICK1;
		}
		if (LBG_not_disabled_by_disableflag(sli) && LBG_mouse_over_object(sli) && (sli->parent == LBG_mouse_window()) && LBG_window_mouse_over_content(sli->parent) && (((!(sli->flags & SFi_CLICK0)) && (!(sli->flags & SFi_CLICK1))) || ((!(sli->flags & SFi_CLICK0)) && ((sli->flags & SFi_CLICK1)))))
		{
			sli->flags |= SFi_OVER;
			sli->knob->bmap = sli->bmaps.bmap_knob_over;
			if (key_pressed(280))
			{
				if(!((!(sli->flags & SFi_CLICK0)) && ((sli->flags & SFi_CLICK1))))
				{
					if(mouse_pos.x < sli->knob->pos_x) sli->knob->pos_x = mouse_pos.x;
					if(mouse_pos.x > sli->knob->pos_x + sli->knob->size_x) sli->knob->pos_x = mouse_pos.x - sli->knob->size_x + 1;
					sli->mg = mouse_pos.x - sli->knob->pos_x;
				}
				
				sli->flags &= ~SFi_CLICK0;
				sli->flags |= SFi_CLICK1;
				sli->knob->bmap = sli->bmaps.bmap_knob_clicked;
			}
		}
		else
		{
			sli->knob->bmap = sli->bmaps.bmap_knob_default;
			if(!(sli->flags & SFi_OVER))
			{
				sli->flags &= ~SFi_OVER;
			}
		}
		if ((!(sli->flags & SFi_CLICK0)) && ((sli->flags & SFi_CLICK1)))
		{
			sli->knob->pos_x = mouse_pos.x - sli->mg;
			LBG_slider_execute(sli,sli->Sliding);
			
			if (sli->size_x - sli->knob->size_x) sli->value = (sli->knob->pos_x-sli->panel->pos_x)*(sli->maximum-sli->minimum)/(sli->size_x-sli->knob->size_x) + sli->minimum;
			else sli->value = 0;
		}
		if ((!(sli->flags & SFi_CLICK0)) && (!(sli->flags & SFi_CLICK1)) && (key_pressed(280)))
		{
			sli->flags |= SFi_CLICK0;
			sli->flags &= ~SFi_CLICK1;
		}
		
	}
	
	
	
	
	
	
	
	sli->value = maxv(sli->value,sli->minimum);
	sli->value = minv(sli->value,sli->maximum);
	sli->knob->pos_x = sli->panel->pos_x + (sli->size_x - sli->knob->size_x)*(sli->value-sli->minimum)/(sli->maximum-sli->minimum)+0.5;
	sli->knob->pos_y = sli->panel->pos_y;
	
	if(sli->flags & SF_EXTERNVAR) *(sli->v) = sli->value;
	
	
	
	
	if(sli->flags & SF_SHOW)
	{
		sli->panel->flags |= SHOW;
		sli->knob->flags |= SHOW;
	}
	else
	{
		sli->panel->flags &= ~SHOW;
		sli->knob->flags &= ~SHOW;
	}
	
	
	
	return sli->next;
}


LBG_SLIDER* LBG_update_slider (LBG_SLIDER* sli)
{
	LBG_object_upate_pos(sli);
	LBG_object_upate_size(sli);
	LBG_update_slider_layer(sli);
	ptr_remove(sli->panel->bmap);
	sli->panel->bmap = bmap_createblack(sli->size_x,sli->size_y,32);
	LBG_progressbar_bitmap(sli->panel->bmap,sli->bmaps,sli->size_x,sli->size_y);
}



LBG_SLIDER* LBG_destroy_slider (LBG_SLIDER* sli)
{
	LBG_slider_execute(sli,sli->Destroy);
	
	ptr_remove(sli->panel);
	ptr_remove(sli->knob);
	
	LBG_object_destroy_infoboxes(sli);
	LBG_object_destroy_rightclicks(sli);
	
	LBG_SLIDER* next = sli->next;
	if(sli->previous) sli->previous->next = sli->next;
	else LBG_SLIDER_FIRST = sli->next;
	if(sli->next) sli->next->previous = sli->previous;
	
	free(sli);
	LBG_object_make_handles_invalid(sli);
	return(next);
}



void LBG_sbmaps_destroy_2frames (LBG_SLIDER_BMAPS* bmaps) // for internal use
{
	wait(2);
	free(bmaps);
}

LBG_SLIDER_BMAPS* LBG_sbmaps (BMAP* bmap_left, BMAP* bmap_middle, BMAP* bmap_right, BMAP* bmap_knob_default, BMAP* bmap_knob_over, BMAP* bmap_knob_clicked)
{
	LBG_SLIDER_BMAPS* bmaps = malloc(sizeof(LBG_SLIDER_BMAPS));
	bmaps->bmap_left = bmap_left;
	bmaps->bmap_middle = bmap_middle;
	bmaps->bmap_right = bmap_right;
	bmaps->bmap_knob_default = bmap_knob_default;
	bmaps->bmap_knob_over = bmap_knob_over;
	bmaps->bmap_knob_clicked = bmap_knob_clicked;
	LBG_sbmaps_destroy_2frames(bmaps);
	return(bmaps);
}