/*
stype:
1 = Window
2 = Button
3 = Panel
4 = Text
5 = View
6 = Checkbox
7 = Infobox
8 = Progress Bar
9 = horizontal scrollbar
10 = vertical scrollbar
11 = slider
12 reseved for vertical slider
13 = Listbox
14 = List item
15 = Rightclick menu
16 = ComboBox
17 = Digits
18 = Editbox
*/





typedef struct LBG_WBORDER_BMAPS
{
	BMAP* bmap_titlebar_left;
	BMAP* bmap_titlebar_middle;
	BMAP* bmap_titlebar_right;
	BMAP* bmap_border_left;
	BMAP* bmap_border_right;
	BMAP* bmap_border_bottomleft;
	BMAP* bmap_border_bottom;
	BMAP* bmap_border_bottomright;
} LBG_WBORDER_BMAPS;

typedef struct LBG_CBORDER_BMAPS
{
	BMAP* bmap_topleft;
	BMAP* bmap_top;
	BMAP* bmap_topright;
	BMAP* bmap_left;
	BMAP* bmap_right;
	BMAP* bmap_bottomleft;
	BMAP* bmap_bottom;
	BMAP* bmap_bottomright;
	BMAP* bmap_center;
} LBG_CBORDER_BMAPS;

typedef struct LBG_TBUTTON_BMAPS // titlebar buttons
{
	BMAP* bmap_x_default;
	BMAP* bmap_x_over;
	BMAP* bmap_x_clicked;
	
	BMAP* bmap_max_default;
	BMAP* bmap_max_over;
	BMAP* bmap_max_clicked;
	
	BMAP* bmap_res_default;
	BMAP* bmap_res_over;
	BMAP* bmap_res_clicked;
} LBG_TBUTTON_BMAPS;

typedef struct LBG_WINDOW
{
	long ssize;
	long stype;
	
	struct LBG_WINDOW* next;
	struct LBG_WINDOW* previous;
	
	var skill_x; // Free to use for the user
	var skill_y;
	var skill_z;
	
	
	struct LBG_WINDOW* parent;
	var layer;
	long flags;
	
	var pos_x, pos_y; 	// Position (bei Buttons etc. relativ zur Position des Parent-Windows (oder ber flag?))
	var size_x, size_y; 	// Gre
	var scale_x,scale_y;
	
	PANEL* panel;
	
	STRING* caption;
	TEXT* text;
	var tpos_x;
	var tpos_y;
	
	void Destroy();
	
	var cpos_x, cpos_y; 	// Position des Inhalts, d.h. ohne Rahmen und Titelleiste
	var csize_x, csize_y; 	// Gre des Inhalts
	
	var minsize_x; // Minimum size when scaling
	var minsize_y;
	var maxsize_x; // Maximum size when scaling
	var maxsize_y;
	
	var mg_pos_x; // mouse grap
	var mg_pos_y; // OR backup size when maximized
	
	var bg_ver; // border grap (vertical)
	var bg_hor; // OR backup position when maximized
	
	var bkx; // backup positions when scaling from top or left
	var bky;
	
	long flags2;
	
	
	LBG_WBORDER_BMAPS bbmaps;
	LBG_CBORDER_BMAPS cbmaps;
	LBG_TBUTTON_BMAPS tbmaps;
	
	void* xbutton; // X button (close button) type:LBG_BUTTON
	void* maxbutton; // maximize button
	
	var xbutton_offx;
	var xbutton_offy;
	
	
	var lastsize_x;
	var lastsize_y;
	
	
	var ctype; // content type
	void* content;
	
	var hscroll_height;
	var vscroll_width;
	
	var hscrollamount;
	var vscrollamount;
	
	var scroll_minsize_x;
	var scroll_minsize_y;
	
	var scroll_bordersize_x;
	var scroll_bordersize_y;
	
	void Close();
	void Maximize();
	void Restore();
	void Resize();
	void Resizing();
	void Move();
	void Moving();
	
} LBG_WINDOW;

typedef struct LBG_BUTTON
{
	long ssize;
	long stype;
	
	struct LBG_BUTTON* next;
	struct LBG_BUTTON* previous;
	
	var skill_x; // Free to use for the user
	var skill_y;
	var skill_z;
	
	
	LBG_WINDOW* parent;
	var layer;
	long flags;
	
	var pos_x, pos_y; 	// Position (bei Buttons etc. relativ zur Position des Parent-Windows (oder ber flag?))
	var size_x, size_y; 	// Gre
	var scale_x,scale_y;
	
	PANEL* panel;
	
	STRING* caption;
	TEXT* text;
	var tpos_x;
	var tpos_y;
	
	void Destroy();
	
	var tpos_over_x; // relative to tpos_x
	var tpos_over_y;
	var tpos_clicked_x;
	var tpos_clicked_y;
	COLOR color_default;
	COLOR color_over;
	COLOR color_clicked;
	COLOR color_disabled;
	
	
	
	void Event();
	void Over();
	void Leave();
	int Condition();
	
	
	BMAP* bmap_default;
	BMAP* bmap_over;
	BMAP* bmap_clicked;
	BMAP* bmap_active;
	BMAP* bmap_overactive;
	BMAP* bmap_disabled;
	
	
} LBG_BUTTON;

typedef struct LBG_BUTTON_BMAPS
{
	BMAP* bmap_default;
	BMAP* bmap_over;
	BMAP* bmap_clicked;
	BMAP* bmap_active;
	BMAP* bmap_overactive;
	BMAP* bmap_disabled;
} LBG_BUTTON_BMAPS;




typedef struct LBG_PANEL
{
	long ssize;
	long stype;
	
	struct LBG_PANEL* next;
	struct LBG_PANEL* previous;
	
	var skill_x; // Free to use for the user
	var skill_y;
	var skill_z;
	
	
	LBG_WINDOW* parent;
	var layer;
	long flags;
	
	var pos_x, pos_y; 	// Position (bei Buttons etc. relativ zur Position des Parent-Windows (oder ber flag?))
	var size_x, size_y; 	// Gre
	var scale_x,scale_y;
	
	PANEL* panel;
	
	void Destroy();
} LBG_PANEL;


typedef struct LBG_TEXT
{
	long ssize;
	long stype;
	
	struct LBG_TEXT* next;
	struct LBG_TEXT* previous;
	
	var skill_x; // Free to use for the user
	var skill_y;
	var skill_z;
	
	
	LBG_WINDOW* parent;
	var layer;
	long flags;
	
	var pos_x, pos_y; 	// Position (bei Buttons etc. relativ zur Position des Parent-Windows (oder ber flag?))
	var size_x, size_y; 	// Gre
	var scale_x,scale_y;
	
	TEXT* text;
	
	void Destroy();
} LBG_TEXT;



typedef struct LBG_CHECKBOX
{
	long ssize;
	long stype;
	
	struct LBG_CHECKBOX* next;
	struct LBG_CHECKBOX* previous;
	
	var skill_x; // Free to use for the user
	var skill_y;
	var skill_z;
	
	
	LBG_WINDOW* parent;
	var layer;
	long flags;
	
	var pos_x, pos_y; 	// Position (bei Buttons etc. relativ zur Position des Parent-Windows (oder ber flag?))
	var size_x, size_y; 	// Gre
	var scale_x,scale_y;
	
	PANEL* panel;
	
	STRING* caption;
	TEXT* text;
	var tpos_x;
	var tpos_y;
	
	void Destroy();
	
	COLOR color_default;
	COLOR color_over;
	COLOR color_clicked;
	COLOR color_disabled;
	
	
	
	void ChangeState();
	void Over();
	void Leave();
	int Condition();
	
	var group; // group for radiobuttons
	
	BMAP* bmap_default;
	BMAP* bmap_over;
	BMAP* bmap_checked;
	BMAP* bmap_checked_over;
	BMAP* bmap_disabled;
	BMAP* bmap_checked_disabled;
	
} LBG_CHECKBOX;

typedef struct LBG_CHECKBOX_BMAPS
{
	BMAP* bmap_default;
	BMAP* bmap_over;
	BMAP* bmap_checked;
	BMAP* bmap_checked_over;
	BMAP* bmap_disabled;
	BMAP* bmap_checked_disabled;
} LBG_CHECKBOX_BMAPS;


typedef struct LBG_INFOBOX
{
	long ssize;
	long stype;
	
	struct LBG_INFOBOX* next;
	struct LBG_INFOBOX* previous;
	
	var skill_x; // Free to use for the user
	var skill_y;
	var skill_z;
	
	
	LBG_WINDOW* target;
	var layer;
	long flags;
	
	var pos_x, pos_y; 	// Position (bei Buttons etc. relativ zur Position des Parent-Windows (oder ber flag?))
	var size_x, size_y; 	// Gre
	var scale_x,scale_y;
	
	PANEL* panel;
	
	STRING* caption;
	TEXT* text;
	var tpos_x;
	var tpos_y;
	
	void Destroy();
	
	LBG_CBORDER_BMAPS bmaps;
	
	var time;
	var counter;
	
	var minsize_x;
	var minsize_y;
	
	void Appear();
	void Disappear();
	int Condition();
	
	
} LBG_INFOBOX;


typedef struct LBG_PROGRESSBAR
{
	long ssize;
	long stype;
	
	struct LBG_PROGRESSBAR* next;
	struct LBG_PROGRESSBAR* previous;
	
	var skill_x; // Free to use for the user
	var skill_y;
	var skill_z;
	
	
	LBG_WINDOW* parent;
	var layer;
	long flags;
	
	var pos_x, pos_y; 	// Position (bei Buttons etc. relativ zur Position des Parent-Windows (oder ber flag?))
	var size_x, size_y; 	// Gre
	var scale_x,scale_y;
	
	PANEL* panel;
	
	STRING* caption;
	TEXT* text;
	var tpos_x;
	var tpos_y;
	
	void Destroy();
	
	PANEL* bar;
	
	BMAP* bmap_pan_left;
	BMAP* bmap_pan_middle;
	BMAP* bmap_pan_right;
	BMAP* bmap_bar;
	
	var maximum;
	var progress;
	STRING* format;
	
	var barpos_x;
	var barpos_y;
	
	var bar_width;
	
} LBG_PROGRESSBAR;

typedef struct LBG_PROGRESSBAR_BMAPS
{
	BMAP* bmap_pan_left;
	BMAP* bmap_pan_middle;
	BMAP* bmap_pan_right;
	BMAP* bmap_bar;
} LBG_PROGRESSBAR_BMAPS;



typedef struct LBG_HSCROLLBAR_BMAPS
{
	BMAP* bmap_left;
	BMAP* bmap_middle;
	BMAP* bmap_right;
	BMAP* bmap_bar;
	BMAP* bmap_corner;
} LBG_HSCROLLBAR_BMAPS;

typedef struct LBG_HSCROLLBAR
{
	long ssize;
	long stype;
	
	struct LBG_HSCROLLBAR* next;
	struct LBG_HSCROLLBAR* previous;
	
	var skill_x; // Free to use for the user
	var skill_y;
	var skill_z;
	
	
	LBG_WINDOW* target;
	var layer;
	long flags;
	
	var pos_x, pos_y; 	// Position (bei Buttons etc. relativ zur Position des Parent-Windows (oder ber flag?))
	var size_x, size_y; 	// Gre
	var scale_x,scale_y;
	
	PANEL* panel;
	
	void Destroy();
	
	LBG_BUTTON* button_left; // scroll left button
	LBG_BUTTON* button_right; // scroll right button
	PANEL* scrollbar;
	PANEL* corner;
	
	LBG_HSCROLLBAR_BMAPS bmaps;
	
	
	var scrollamount;
	var scrollmax; // Maximum size (or scrollamount?) (or 0 for auto?)
	var ppa; // pixel per "amount unit"
	var wheelspeed;
	
	var mg; // mouse grap
	var buttonspeed;
	
	void Scrolling();
	int Condition();
	
} LBG_HSCROLLBAR;



typedef struct LBG_VSCROLLBAR_BMAPS
{
	BMAP* bmap_top;
	BMAP* bmap_middle;
	BMAP* bmap_bottom;
	BMAP* bmap_bar;
} LBG_VSCROLLBAR_BMAPS;

typedef struct LBG_VSCROLLBAR
{
	long ssize;
	long stype;
	
	struct LBG_VSCROLLBAR* next;
	struct LBG_VSCROLLBAR* previous;
	
	var skill_x; // Free to use for the user
	var skill_y;
	var skill_z;
	
	
	LBG_WINDOW* target;
	var layer;
	long flags;
	
	var pos_x, pos_y; 	// Position (bei Buttons etc. relativ zur Position des Parent-Windows (oder ber flag?))
	var size_x, size_y; 	// Gre
	var scale_x,scale_y;
	
	PANEL* panel;
	
	void Destroy();
	
	LBG_BUTTON* button_top; // scroll left button
	LBG_BUTTON* button_bottom; // scroll right button
	PANEL* scrollbar;
	PANEL* corner;
	
	LBG_VSCROLLBAR_BMAPS bmaps;
	
	
	var scrollamount;
	var scrollmax; // Maximum size (or scrollamount?) (or 0 for auto?)
	var ppa; // pixel per "amount unit"
	var wheelspeed;
	
	var mg; // mouse grap
	var buttonspeed;
	
	void Scrolling();
	int Condition();
	
} LBG_VSCROLLBAR;



typedef struct LBG_SLIDER_BMAPS
{
	BMAP* bmap_left;
	BMAP* bmap_middle;
	BMAP* bmap_right;
	BMAP* bmap_knob_default;
	BMAP* bmap_knob_over;
	BMAP* bmap_knob_clicked;
} LBG_SLIDER_BMAPS;

typedef struct LBG_SLIDER
{
	long ssize;
	long stype;
	
	struct LBG_SLIDER* next;
	struct LBG_SLIDER* previous;
	
	var skill_x; // Free to use for the user
	var skill_y;
	var skill_z;
	
	
	LBG_WINDOW* parent;
	var layer;
	long flags;
	
	var pos_x, pos_y; 	// Position (bei Buttons etc. relativ zur Position des Parent-Windows (oder ber flag?))
	var size_x, size_y; 	// Gre
	var scale_x,scale_y;
	
	PANEL* panel;
	
	void Destroy();
	
	PANEL* knob;
	
	LBG_SLIDER_BMAPS bmaps;
	
	
	var minimum;
	var maximum;
	var value;
	var* v;
	
	var mg;
	

	void Sliding();
	
} LBG_SLIDER;



typedef struct LBG_LISTITEM_BMAPS
{
	BMAP* bmap_left;
	BMAP* bmap_middle;
	BMAP* bmap_right;
} LBG_LISTITEM_BMAPS;

typedef struct LBG_LISTITEM
{
	long ssize;
	long stype;
	
	struct LBG_LISTITEM* next;
	struct LBG_LISTITEM* previous;
	
	var skill_x; // Free to use for the user
	var skill_y;
	var skill_z;
	
	
	LBG_WINDOW* parent;
	var layer;
	long flags;
	
	var pos_x, pos_y; 	// Position (bei Buttons etc. relativ zur Position des Parent-Windows (oder ber flag?))
	var size_x, size_y; 	// Gre
	var scale_x,scale_y;
	
	PANEL* panel;
	
	STRING* caption;
	TEXT* text;
	
	void Destroy();
	void Select();
	void Unselect();
	
	
} LBG_LISTITEM;


typedef struct LBG_LISTBOX_BMAPS
{
	BMAP* bmap_topleft;
	BMAP* bmap_top;
	BMAP* bmap_topright;
	BMAP* bmap_left;
	BMAP* bmap_right;
	BMAP* bmap_bottomleft;
	BMAP* bmap_bottom;
	BMAP* bmap_bottomright;
	BMAP* bmap_center;
} LBG_LISTBOX_BMAPS;

typedef struct LBG_LISTBOX
{
	long ssize;
	long stype;
	
	struct LBG_LISTBOX* next;
	struct LBG_LISTBOX* previous;
	
	var skill_x; // Free to use for the user
	var skill_y;
	var skill_z;
	
	
	LBG_WINDOW* parent;
	var layer;
	long flags;
	
	var pos_x, pos_y; 	// Position (bei Buttons etc. relativ zur Position des Parent-Windows (oder ber flag?))
	var size_x, size_y; 	// Gre
	var scale_x,scale_y;
	
	PANEL* panel;
	
	var tpos_x;
	var tpos_y;
	
	void Destroy();
	
	
	LBG_LISTBOX_BMAPS bmaps;
	
	LBG_LISTITEM_BMAPS bmaps_default;
	LBG_LISTITEM_BMAPS bmaps_over;
	LBG_LISTITEM_BMAPS bmaps_marked;
	
	
	BMAP* bmap_default;
	BMAP* bmap_over;
	BMAP* bmap_marked;
	
	
	LBG_LISTITEM* item_first;
	
	LBG_LISTITEM* marked_item;
	
	var ipos_x, ipos_y; // defines the area of the list items
	var isize_x, isize_y; // (relative to pos_x,y)
	
	var lpos_x, lpos_y; // defines the "real" area of the list items (with the slider size deducted)
	var lsize_x, lsize_y; // and absolute instead of relative
	
	var vscroll_width;
	var vscrollamount;
	
	FONT* font;
	
	var itemheight;
	
	
	COLOR color_default;
	COLOR color_over;
	COLOR color_marked;
	
	void Select();
	
	
} LBG_LISTBOX;



typedef struct LBG_RIGHTCLICK
{
	long ssize;
	long stype;
	
	struct LBG_RIGHTCLICK* next;
	struct LBG_RIGHTCLICK* previous;
	
	var skill_x; // Free to use for the user
	var skill_y;
	var skill_z;
	
	
	//FONT* font;
	LBG_WINDOW* target;
	var layer;
	long flags;
	
	var pos_x, pos_y; 	// Position (bei Buttons etc. relativ zur Position des Parent-Windows (oder ber flag?))
	var size_x, size_y; 	// Gre
	var scale_x,scale_y;
	
	void Destroy();
	
	LBG_LISTBOX* menu;
	
	void Open();
	int Condition();
	
	
} LBG_RIGHTCLICK;


typedef struct LBG_DIGITS
{
	long ssize;
	long stype;
	
	struct LBG_DIGITS* next;
	struct LBG_DIGITS* previous;
	
	var skill_x; // Free to use for the user
	var skill_y;
	var skill_z;
	
	
	//FONT* font;
	LBG_WINDOW* parent;
	var layer;
	long flags;
	
	var pos_x, pos_y; 	// Position (bei Buttons etc. relativ zur Position des Parent-Windows (oder ber flag?))
	var size_x, size_y; 	// Gre
	var scale_x,scale_y;
	
	TEXT* text;
	STRING* caption;
	
	STRING* format;
	
	var value;
	var* v;
	
	void Destroy();
} LBG_DIGITS;


typedef struct LBG_EDITBOX_BMAPS
{
	BMAP* bmap_left;
	BMAP* bmap_middle;
	BMAP* bmap_right;
} LBG_EDITBOX_BMAPS;

typedef struct LBG_EDITBOX
{
	long ssize;
	long stype;
	
	struct LBG_EDITBOX* next;
	struct LBG_EDITBOX* previous;
	
	var skill_x; // Free to use for the user
	var skill_y;
	var skill_z;
	
	
	//FONT* font;
	LBG_WINDOW* parent;
	var layer;
	long flags;
	
	var pos_x, pos_y; 	// Position (bei Buttons etc. relativ zur Position des Parent-Windows (oder ber flag?))
	var size_x, size_y; 	// Gre
	var scale_x,scale_y;
	
	PANEL* panel;
	
	STRING* caption;
	TEXT* text;
	var tpos_x;
	var tpos_y;
	
	void Destroy();
	
	
	LBG_EDITBOX_BMAPS bmaps;
	
	STRING* vstring; // visible string
	STRING* vsleft; // visible string left of the cursor
	STRING* vsright; // visible string right of the cursor
	
	var hscrollamount;
	var cursor_pos;
	
	TEXT* cursor;
	
	var time;
	var counter;
	var max_length;
	
	int Mask(STRING* input);
	void Key();
	
	
	
} LBG_EDITBOX;


typedef struct LBG_COMBOBOX
{
	long ssize;
	long stype;
	
	struct LBG_COMBOBOX* next;
	struct LBG_COMBOBOX* previous;
	
	var skill_x; // Free to use for the user
	var skill_y;
	var skill_z;
	
	
	//FONT* font;
	LBG_WINDOW* parent;
	var layer;
	long flags;
	
	var pos_x, pos_y; 	// Position (bei Buttons etc. relativ zur Position des Parent-Windows (oder ber flag?))
	var size_x, size_y; 	// Gre
	var scale_x,scale_y;
	
	STRING* caption;
	
	void Destroy();
	
	LBG_EDITBOX* editbox;
	LBG_LISTBOX* menu;
	LBG_BUTTON* button;
	
	LBG_LISTITEM* chosen_option;
	
	void Open();
	void Close();
	
	
} LBG_COMBOBOX;








LBG_WINDOW* LBG_WINDOW_FIRST = 0;
LBG_BUTTON* LBG_BUTTON_FIRST = 0;
LBG_PANEL* LBG_PANEL_FIRST = 0;
LBG_TEXT* LBG_TEXT_FIRST = 0;
//LBG_VIEW* LBG_VIEW_FIRST = 0;
LBG_CHECKBOX* LBG_CHECKBOX_FIRST = 0;
LBG_INFOBOX* LBG_INFOBOX_FIRST = 0;
LBG_PROGRESSBAR* LBG_PROGRESSBAR_FIRST = 0;
LBG_HSCROLLBAR* LBG_HSCROLLBAR_FIRST = 0;
LBG_VSCROLLBAR* LBG_VSCROLLBAR_FIRST = 0;
LBG_SLIDER* LBG_SLIDER_FIRST = 0;
LBG_LISTBOX* LBG_LISTBOX_FIRST = 0;
LBG_RIGHTCLICK* LBG_RIGHTCLICK_FIRST = 0;
LBG_COMBOBOX* LBG_COMBOBOX_FIRST = 0;
LBG_DIGITS* LBG_DIGITS_FIRST = 0;
LBG_EDITBOX* LBG_EDITBOX_FIRST = 0;

LBG_WINDOW* LBG_object_last (LBG_WINDOW* obj)
{
	if(!obj) return (NULL);
	while(obj->next)
	{
		obj = obj->next;
	}
	return(obj);
}

LBG_WINDOW* LBG_object_nr (LBG_WINDOW* obj,var nr)
{
	if(!obj) return (NULL);
	var i;
	for(i=0;i<nr;i++)
	{
		if(!obj->next) break;
		obj = obj->next;
	}
	return(obj);
}

var LBG_object_num (LBG_WINDOW* obj)
{
	if(!obj) return (0);
	var i = 1;
	while(obj->next)
	{
		obj = obj->next;
		i++;
	}
	return(i);
}

var LBG_object_getnum (LBG_WINDOW* obj1,LBG_WINDOW* obj2)
{
	if(!obj1) return (0);
	if(!obj2) return (0);
	var i = 0;
	while((obj1 != obj2) && obj1->next)
	{
		obj1 = obj1->next;
		i++;
	}
	return(i);
}




LBG_WINDOW* LBG_event_object;
LBG_WINDOW* LBG_event_window;
LBG_BUTTON* LBG_event_button;
LBG_PANEL* LBG_event_panel;
LBG_TEXT* LBG_event_text;
LBG_CHECKBOX* LBG_event_checkbox;
LBG_INFOBOX* LBG_event_infobox;
LBG_PROGRESSBAR* LBG_event_progressbar;
LBG_HSCROLLBAR* LBG_event_scrollbar;
LBG_HSCROLLBAR* LBG_event_hscrollbar;
LBG_VSCROLLBAR* LBG_event_vscrollbar;
LBG_SLIDER* LBG_event_slider;
LBG_LISTBOX* LBG_event_listbox;
LBG_LISTITEM* LBG_event_listitem;
LBG_RIGHTCLICK* LBG_event_rightclick;
LBG_COMBOBOX* LBG_event_combobox;
LBG_DIGITS* LBG_event_digits;
LBG_EDITBOX* LBG_event_editbox;





typedef struct LBG_HANDLE
{
	long ssize;
	long stype;
	
	struct LBG_HANDLE* next;
	struct LBG_HANDLE* previous;
	LBG_WINDOW* target;
	int valid;
	
} LBG_HANDLE;
LBG_HANDLE* LBG_HANDLE_FIRST = 0;



LBG_HANDLE* LBG_get_eventhandle (LBG_WINDOW* obj)
{
	LBG_HANDLE* h = malloc(sizeof(LBG_HANDLE));
	h->ssize = sizeof(LBG_HANDLE);
	h->stype = -1;
	
	h->target = obj;
	h->valid = 1;
	
	h->next = NULL;
	if(LBG_HANDLE_FIRST == NULL)
	{
		LBG_HANDLE_FIRST = h;
		h->previous = NULL;
	}
	else
	{
		h->previous = LBG_object_last(LBG_HANDLE_FIRST);
		h->previous->next = h;
	}
	return h;
}

void LBG_object_make_handles_invalid (LBG_WINDOW* obj)
{
	LBG_HANDLE* h = LBG_HANDLE_FIRST;
	while(h)
	{
		if(h->target == obj) h->valid = 0;
		h = h->next;
	}
}

LBG_HANDLE* LBG_destroy_handle (LBG_HANDLE* h)
{
	LBG_HANDLE* next = h->next;
	if(h->previous) h->previous->next = h->next;
	else LBG_HANDLE_FIRST = h->next;
	if(h->next) h->next->previous = h->previous;
	
	free(h);
	return(next);
}