//-------------------------------------------------------------------------------------------------------
// LBGUI Small Demo - by Lukas Brozio
// smalldemo.c
// Version 1.0 as of 28-July-2010
//-------------------------------------------------------------------------------------------------------


// This script is intended as a little help, if you don't know exactly how to create certain GUI
// elements. If you are looking for a demo of the features of LBGUI, use demo.c.
// The interesting part, where the GUI elements are created, is of course in main.c.


//-------------------------------------------------------------------------------------------------------
// Includes


#include <acknex.h>
#include <default.c>
#include "lbgui.h"


//-------------------------------------------------------------------------------------------------------
// Bitmap definitions

BMAP* kl_button1_tga = "kl_button1.tga";
BMAP* kl_button2_tga = "kl_button2.tga";
BMAP* kl_button3_tga = "kl_button3.tga";
BMAP* kl_button4_tga = "kl_button4.tga";
BMAP* kl_button5_tga = "kl_button5.tga";
BMAP* kl_button6_tga = "kl_button6.tga";

BMAP* window_titlebar_left_tga = "window_titlebar_left.tga";
BMAP* window_titlebar_middle_tga = "window_titelbar_middle.tga";
BMAP* window_titlebar_right_tga = "window_titlebar_right.tga";
BMAP* window_titlebar_seperator_tga = "window_titlebar_seperator.tga";

BMAP* window_border_left_tga = "window_border_left.tga";
BMAP* window_border_right_tga = "window_border_right.tga";
BMAP* window_border_bottomleft_tga = "window_border_bottomleft.tga";
BMAP* window_border_bottom_tga = "window_border_bottom.tga";
BMAP* window_border_bottomright_tga = "window_border_bottomright.tga";

BMAP* window_content_topleft_tga = "window_content_topleft.tga";
BMAP* window_content_top_tga = "window_content_top.tga";
BMAP* window_content_topright_tga = "window_content_topright.tga";
BMAP* window_content_left_tga = "window_content_left.tga";
BMAP* window_content_right_tga = "window_content_right.tga";
BMAP* window_content_bottomleft_tga = "window_content_bottomleft.tga";
BMAP* window_content_bottom_tga = "window_content_bottom.tga";
BMAP* window_content_bottomright_tga = "window_content_bottomright.tga";
BMAP* window_content_center_tga = "window_content_center.tga";

BMAP* xbutton1_tga = "xbutton1.tga";
BMAP* xbutton2_tga = "xbutton2.tga";
BMAP* xbutton3_tga = "xbutton3.tga";
BMAP* maxbutton1_tga = "maxbutton1.tga";
BMAP* maxbutton2_tga = "maxbutton2.tga";
BMAP* maxbutton3_tga = "maxbutton3.tga";
BMAP* resbutton1_tga = "resbutton1.tga";
BMAP* resbutton2_tga = "resbutton2.tga";
BMAP* resbutton3_tga = "resbutton3.tga";

BMAP* checkbox_default_tga = "checkbox_default.tga";
BMAP* checkbox_over_tga = "checkbox_over.tga";
BMAP* checkbox_checked_tga = "checkbox_checked.tga";
BMAP* checkbox_checked_over_tga = "checkbox_checked_over.tga";
BMAP* checkbox_disabled_tga = "checkbox_disabled.tga";
BMAP* checkbox_checked_disabled_tga = "checkbox_checked_disabled.tga";

BMAP* radiobutton_default_tga = "radiobutton_default.tga";
BMAP* radiobutton_over_tga = "radiobutton_over.tga";
BMAP* radiobutton_checked_tga = "radiobutton_checked.tga";
BMAP* radiobutton_checked_over_tga = "radiobutton_checked_over.tga";
BMAP* radiobutton_disabled_tga = "radiobutton_disabled.tga";
BMAP* radiobutton_checked_disabled_tga = "radiobutton_checked_disabled.tga";

BMAP* infobox_topleft_tga = "infobox_topleft.tga";
BMAP* infobox_top_tga = "infobox_top.tga";
BMAP* infobox_topright_tga = "infobox_topright.tga";
BMAP* infobox_left_tga = "infobox_left.tga";
BMAP* infobox_right_tga = "infobox_right.tga";
BMAP* infobox_bottomleft_tga = "infobox_bottomleft.tga";
BMAP* infobox_bottom_tga = "infobox_bottom.tga";
BMAP* infobox_bottomright_tga = "infobox_bottomright.tga";
BMAP* infobox_center_tga = "infobox_center.tga";

BMAP* progressbar_left_tga = "progressbar_left.tga";
BMAP* progressbar_middle_tga = "progressbar_middle.tga";
BMAP* progressbar_right_tga = "progressbar_right.tga";
BMAP* progressbar_bar_tga = "progressbar_bar.tga";

BMAP* hscrollbar_left_tga = "hscrollbar_left.tga";
BMAP* hscrollbar_middle_tga = "hscrollbar_middle.tga";
BMAP* hscrollbar_right_tga = "hscrollbar_right.tga";
BMAP* hscrollbar_bar_tga = "hscrollbar_bar.tga";
BMAP* hscrollbar_corner_tga = "hscrollbar_corner.tga";

BMAP* hscrollbar_left1_tga = "hscrollbar_left1.tga";
BMAP* hscrollbar_left2_tga = "hscrollbar_left2.tga";
BMAP* hscrollbar_left3_tga = "hscrollbar_left3.tga";

BMAP* hscrollbar_right1_tga = "hscrollbar_right1.tga";
BMAP* hscrollbar_right2_tga = "hscrollbar_right2.tga";
BMAP* hscrollbar_right3_tga = "hscrollbar_right3.tga";

BMAP* vscrollbar_top_tga = "vscrollbar_top.tga";
BMAP* vscrollbar_middle_tga = "vscrollbar_middle.tga";
BMAP* vscrollbar_bottom_tga = "vscrollbar_bottom.tga";
BMAP* vscrollbar_bar_tga = "vscrollbar_bar.tga";
BMAP* vscrollbar_corner_tga = "hscrollbar_corner.tga";

BMAP* vscrollbar_up1_tga = "vscrollbar_up1.tga";
BMAP* vscrollbar_up2_tga = "vscrollbar_up2.tga";
BMAP* vscrollbar_up3_tga = "vscrollbar_up3.tga";

BMAP* vscrollbar_down1_tga = "vscrollbar_down1.tga";
BMAP* vscrollbar_down2_tga = "vscrollbar_down2.tga";
BMAP* vscrollbar_down3_tga = "vscrollbar_down3.tga";

BMAP* slider_left_tga = "slider_left.tga";
BMAP* slider_middle_tga = "slider_middle.tga";
BMAP* slider_right_tga = "slider_right.tga";
BMAP* slider_knob1_tga = "slider_knob1.tga";
BMAP* slider_knob2_tga = "slider_knob2.tga";
BMAP* slider_knob3_tga = "slider_knob3.tga";

BMAP* listbox_topleft_tga = "listbox_topleft.tga";
BMAP* listbox_top_tga = "listbox_top.tga";
BMAP* listbox_topright_tga = "listbox_topright.tga";
BMAP* listbox_left_tga = "listbox_left.tga";
BMAP* listbox_right_tga = "listbox_right.tga";
BMAP* listbox_bottomleft_tga = "listbox_bottomleft.tga";
BMAP* listbox_bottom_tga = "listbox_bottom.tga";
BMAP* listbox_bottomright_tga = "listbox_bottomright.tga";
BMAP* listbox_center_tga = "listbox_center.tga";

BMAP* listitem_left_tga = "listitem_left.tga";
BMAP* listitem_middle_tga = "listitem_middle.tga";
BMAP* listitem_right_tga = "listitem_right.tga";

BMAP* listitem_over_left_tga = "listitem_over_left.tga";
BMAP* listitem_over_middle_tga = "listitem_over_middle.tga";
BMAP* listitem_over_right_tga = "listitem_over_right.tga";

BMAP* listitem_marked_left_tga = "listitem_marked_left.tga";
BMAP* listitem_marked_middle_tga = "listitem_marked_middle.tga";
BMAP* listitem_marked_right_tga = "listitem_marked_right.tga";

BMAP* editbox_left_tga = "editbox_left.tga";
BMAP* editbox_middle_tga = "editbox_middle.tga";
BMAP* editbox_right_tga = "editbox_right.tga";

BMAP* combobox_button1_tga = "combobox_button1.tga";
BMAP* combobox_button2_tga = "combobox_button2.tga";
BMAP* combobox_button3_tga = "combobox_button3.tga";

BMAP* brogames_tga = "brogames.tga";


BMAP* mouse_default_tga = "mouse_default.tga";
BMAP* mouse_text_tga = "mouse_text.tga";
BMAP* mouse_scale_hor_tga = "mouse_scale_hor.tga";
BMAP* mouse_scale_ver_tga = "mouse_scale_ver.tga";
BMAP* mouse_scale_diag1_tga = "mouse_scale_diag1.tga";
BMAP* mouse_scale_diag2_tga = "mouse_scale_diag2.tga";


PANEL* mouse_pan =
{
	bmap = mouse_default_tga;
	layer = 999999;
	flags = UNTOUCHABLE;
}


//-------------------------------------------------------------------------------------------------------
// Panel and Text.
// Those are used as examples how to include "normal" panels and texts in the GUI.
// Look at main.c to see it.

PANEL* pan1 =
{
	bmap = brogames_tga;
}
TEXT* txt1 =
{
	string("Hello. This demo is mainly to show how how to use LBGUI. Take a look at the source code.\nIf you want to see the features of LBGUI, have a look at demo.c. You can of course also look at the source code of demo.c, but it's poorly commented.");
	font = LBG_button_font;
	red = 0;
	green = 192;
	blue = 0;
	flags = WWRAP;
}


//-------------------------------------------------------------------------------------------------------
// Bitmap structs.
//	These structs contain the bitmaps for certain objects.
//	If you want to create an object only once, you can use functions like LBG_wbbmaps to create temporary structs.

LBG_WBORDER_BMAPS win_bbmaps;
LBG_CBORDER_BMAPS win_cbmaps;
LBG_TBUTTON_BMAPS win_tbmaps;
LBG_CHECKBOX_BMAPS checkbox_bmaps;
LBG_CHECKBOX_BMAPS radiobutton_bmaps;
LBG_SLIDER_BMAPS slider_bmaps;
LBG_PROGRESSBAR_BMAPS progressbar_bmaps;
LBG_LISTBOX_BMAPS listbox_bmaps;
LBG_CBORDER_BMAPS infobox_bmaps;



//-------------------------------------------------------------------------------------------------------
// Buttom Condition
// A function like this can be used to check if a button should really consider the mouse as over it.
// You can e.g. use pixel_for_bmap for this, or, as I did, just exclude the round corners manually.

int button_condition ()
{
	if (mouse_pos.y == LBG_event_button->panel->pos_y) if ((mouse_pos.x <= LBG_event_button->panel->pos_x + 4) || (mouse_pos.x >= LBG_event_button->panel->pos_x + 123)) return 0;
	if (mouse_pos.y == LBG_event_button->panel->pos_y + 1) if ((mouse_pos.x <= LBG_event_button->panel->pos_x + 2) || (mouse_pos.x >= LBG_event_button->panel->pos_x + 125)) return 0;
	if (mouse_pos.y == LBG_event_button->panel->pos_y + 2) if ((mouse_pos.x <= LBG_event_button->panel->pos_x + 1) || (mouse_pos.x >= LBG_event_button->panel->pos_x + 126)) return 0;
	if (mouse_pos.y == LBG_event_button->panel->pos_y + 3) if ((mouse_pos.x <= LBG_event_button->panel->pos_x ) || (mouse_pos.x >= LBG_event_button->panel->pos_x + 127)) return 0;
	if (mouse_pos.y == LBG_event_button->panel->pos_y + 4) if ((mouse_pos.x <= LBG_event_button->panel->pos_x) || (mouse_pos.x >= LBG_event_button->panel->pos_x + 127)) return 0;
	if (mouse_pos.y == LBG_event_button->panel->pos_y + 31) if ((mouse_pos.x <= LBG_event_button->panel->pos_x + 4) || (mouse_pos.x >= LBG_event_button->panel->pos_x + 123)) return 0;
	if (mouse_pos.y == LBG_event_button->panel->pos_y + 30) if ((mouse_pos.x <= LBG_event_button->panel->pos_x + 2) || (mouse_pos.x >= LBG_event_button->panel->pos_x + 125)) return 0;
	if (mouse_pos.y == LBG_event_button->panel->pos_y + 29) if ((mouse_pos.x <= LBG_event_button->panel->pos_x + 1) || (mouse_pos.x >= LBG_event_button->panel->pos_x + 126)) return 0;
	if (mouse_pos.y == LBG_event_button->panel->pos_y + 28) if ((mouse_pos.x <= LBG_event_button->panel->pos_x ) || (mouse_pos.x >= LBG_event_button->panel->pos_x + 127)) return 0;
	if (mouse_pos.y == LBG_event_button->panel->pos_y + 27) if ((mouse_pos.x <= LBG_event_button->panel->pos_x) || (mouse_pos.x >= LBG_event_button->panel->pos_x + 127)) return 0;
	return 1;
}


//-------------------------------------------------------------------------------------------------------
// Example sound.
// This function is used by the button as an example event.

SOUND* beep_snd = "beep.wav";
void button_beep()
{
	snd_play(beep_snd,100,0);
}


//-------------------------------------------------------------------------------------------------------
// Example rightclick functions.
// These functions are used by the rightclick menu to change the progressbar.

LBG_PROGRESSBAR* progressbar1;
void progressbar1_set_to_0 ()
{
	progressbar1->progress = 0;
}
void progressbar1_set_to_100 ()
{
	progressbar1->progress = 100;
}
void progressbar1_increase_by_10 ()
{
	progressbar1->progress += 10;
}
void progressbar1_decrease_by_10 ()
{
	progressbar1->progress -= 10;
}


//-------------------------------------------------------------------------------------------------------
// Radiobuttons to decide between the Windows mouse and a bitmap mouse


LBG_CHECKBOX* radiobutton_windows_mouse=0;
LBG_CHECKBOX* radiobutton_bitmap_mouse=0;


//-------------------------------------------------------------------------------------------------------
// main function
// The most interesting part of the script.


void main ()
{
	// Assign the bitmaps to the bitmap structs
	
	win_bbmaps.bmap_titlebar_left = window_titlebar_left_tga;
	win_bbmaps.bmap_titlebar_middle = window_titlebar_middle_tga;
	win_bbmaps.bmap_titlebar_right = window_titlebar_right_tga;
	win_bbmaps.bmap_border_left = window_border_left_tga;
	win_bbmaps.bmap_border_right = window_border_right_tga;
	win_bbmaps.bmap_border_bottomleft = window_border_bottomleft_tga;
	win_bbmaps.bmap_border_bottom = window_border_bottom_tga;
	win_bbmaps.bmap_border_bottomright = window_border_bottomright_tga;
	
	win_cbmaps.bmap_topleft = window_content_topleft_tga;
	win_cbmaps.bmap_top = window_content_top_tga;
	win_cbmaps.bmap_topright = window_content_topright_tga;
	win_cbmaps.bmap_left = window_content_left_tga;
	win_cbmaps.bmap_right = window_content_right_tga;
	win_cbmaps.bmap_bottomleft = window_content_bottomleft_tga;
	win_cbmaps.bmap_bottom = window_content_bottom_tga;
	win_cbmaps.bmap_bottomright = window_content_bottomright_tga;
	win_cbmaps.bmap_center = window_content_center_tga;
	
	win_tbmaps.bmap_x_default = xbutton1_tga;
	win_tbmaps.bmap_x_over = xbutton2_tga;
	win_tbmaps.bmap_x_clicked = xbutton3_tga;
	win_tbmaps.bmap_max_default = maxbutton1_tga;
	win_tbmaps.bmap_max_over = maxbutton2_tga;
	win_tbmaps.bmap_max_clicked = maxbutton3_tga;
	win_tbmaps.bmap_res_default = resbutton1_tga;
	win_tbmaps.bmap_res_over = resbutton2_tga;
	win_tbmaps.bmap_res_clicked = resbutton3_tga;
	
	checkbox_bmaps.bmap_default = checkbox_default_tga;
	checkbox_bmaps.bmap_over = checkbox_over_tga;
	checkbox_bmaps.bmap_checked = checkbox_checked_tga;
	checkbox_bmaps.bmap_checked_over = checkbox_checked_over_tga;
	checkbox_bmaps.bmap_disabled = checkbox_disabled_tga;
	checkbox_bmaps.bmap_checked_disabled = checkbox_checked_disabled_tga;
	
	radiobutton_bmaps.bmap_default = radiobutton_default_tga;
	radiobutton_bmaps.bmap_over = radiobutton_over_tga;
	radiobutton_bmaps.bmap_checked = radiobutton_checked_tga;
	radiobutton_bmaps.bmap_checked_over = radiobutton_checked_over_tga;
	radiobutton_bmaps.bmap_disabled = radiobutton_disabled_tga;
	radiobutton_bmaps.bmap_checked_disabled = radiobutton_checked_disabled_tga;
	
	slider_bmaps.bmap_left = slider_left_tga;
	slider_bmaps.bmap_middle = slider_middle_tga;
	slider_bmaps.bmap_right = slider_right_tga;
	slider_bmaps.bmap_knob_default = slider_knob1_tga;
	slider_bmaps.bmap_knob_over = slider_knob2_tga;
	slider_bmaps.bmap_knob_clicked = slider_knob3_tga;
	
	progressbar_bmaps.bmap_pan_left = progressbar_left_tga;
	progressbar_bmaps.bmap_pan_middle = progressbar_middle_tga;
	progressbar_bmaps.bmap_pan_right = progressbar_right_tga;
	progressbar_bmaps.bmap_bar = progressbar_bar_tga;
	
	listbox_bmaps.bmap_topleft = listbox_topleft_tga;
	listbox_bmaps.bmap_top = listbox_top_tga;
	listbox_bmaps.bmap_topright = listbox_topright_tga;
	listbox_bmaps.bmap_left = listbox_left_tga;
	listbox_bmaps.bmap_right = listbox_right_tga;
	listbox_bmaps.bmap_bottomleft = listbox_bottomleft_tga;
	listbox_bmaps.bmap_bottom = listbox_bottom_tga;
	listbox_bmaps.bmap_bottomright = listbox_bottomright_tga;
	listbox_bmaps.bmap_center = listbox_center_tga;
	
	infobox_bmaps.bmap_topleft = infobox_topleft_tga;
	infobox_bmaps.bmap_top = infobox_top_tga;
	infobox_bmaps.bmap_topright = infobox_topright_tga;
	infobox_bmaps.bmap_left = infobox_left_tga;
	infobox_bmaps.bmap_right = infobox_right_tga;
	infobox_bmaps.bmap_bottomleft = infobox_bottomleft_tga;
	infobox_bmaps.bmap_bottom = infobox_bottom_tga;
	infobox_bmaps.bmap_bottomright = infobox_bottomright_tga;
	infobox_bmaps.bmap_center = infobox_center_tga;
	
	
	wait(1); // Wait until video functions can be used
	video_window(nullvector,vector(960,600,0),0,0); // Set window size to 960x600
	video_set(960,600,0,0); // Set resolution to 960x600
	
	mouse_pointer = 2; // Standard arrow
	mouse_mode = 3; // Automatically update mouse_pos
	screen_color.red = 1; // Black background
	screen_color.green = 0;
	screen_color.blue = 0;
	
	LBGUI_open(); // Open the GUI
	on_exit = LBGUI_close; // Close it when the application is terminated
	LBG_flags |= LBGUI_PROTECTMOUSE; // This prevents windows to be moves outside the engine window
	
	// Create a button (using a temporary bitmaps struct), with a beep as event
	LBG_BUTTON* button1 = LBG_create_button(0,64,32,16,4,"Button",LBG_bbmaps(kl_button1_tga,kl_button2_tga,kl_button3_tga,kl_button4_tga,kl_button5_tga,kl_button6_tga),button_beep,BF_SHOW);
	button1->Condition = button_condition; // Assign the Condition of the button. The button will only react on the mouse if is returns non-zero.
	button1->tpos_clicked_x = 1; // When the button is clicked, its text should move 1 pixel to the right...
	button1->tpos_clicked_y = 1; // ... and 1 pixel down.
	
	// Create a checkbox (using the checkbox_bmaps struct). It's checked on default.
	LBG_CHECKBOX* checkbox1 = LBG_create_checkbox(0, 64, 96, 32, -4, "Checkbox",&checkbox_bmaps, CF_SHOW | CF_CHECKED);
	vec_set(checkbox1->color_default,vector(0,192,0)); // Set the default color of the checkbox to green.
	vec_set(checkbox1->color_over,vector(0,212,0));		// Make the green brighter when the mouse is over the checkbox.
	vec_set(checkbox1->color_clicked,vector(0,192,0));	// Make it back to dark when the checkbox is clicked.
	
	// Create a radiobutton. It's created by the same function and is only distinguished as radiobutton by the CF_RADIO flag.
	LBG_CHECKBOX* radiobutton_a1 = LBG_create_checkbox(0, 64, 128, 32, -4, "Radiobutton A1",&radiobutton_bmaps, CF_SHOW | CF_RADIO);
	vec_set(radiobutton_a1->color_default,vector(0,192,0)); vec_set(radiobutton_a1->color_over,vector(0,212,0)); vec_set(radiobutton_a1->color_clicked,vector(0,192,0));
	
	// An other radiobutton, created exactly the same way
	LBG_CHECKBOX* radiobutton_a2 = LBG_create_checkbox(0, 64, 160, 32, -4, "Radiobutton A2",&radiobutton_bmaps, CF_SHOW | CF_RADIO);
	vec_set(radiobutton_a2->color_default,vector(0,192,0)); vec_set(radiobutton_a2->color_over,vector(0,212,0)); vec_set(radiobutton_a2->color_clicked,vector(0,192,0));
	
	// Create an other group of radiobuttons
	LBG_CHECKBOX* radiobutton_b1 = LBG_create_checkbox(0, 256, 128, 32, -4, "Radiobutton B1",&radiobutton_bmaps, CF_SHOW | CF_RADIO);
	vec_set(radiobutton_b1->color_default,vector(0,192,0)); vec_set(radiobutton_b1->color_over,vector(0,212,0)); vec_set(radiobutton_b1->color_clicked,vector(0,192,0));
	LBG_CHECKBOX* radiobutton_b2 = LBG_create_checkbox(0, 256, 160, 32, -4, "Radiobutton B2",&radiobutton_bmaps, CF_SHOW | CF_RADIO);
	vec_set(radiobutton_b2->color_default,vector(0,192,0)); vec_set(radiobutton_b2->color_over,vector(0,212,0)); vec_set(radiobutton_b2->color_clicked,vector(0,192,0));
	radiobutton_b1->group = 1; // To make them an other group, we just have to change their group. On default, their group is always 0.
	radiobutton_b2->group = 1; // This wouldn't be necessary if the groups would be on different windows.
	
	// Create a progresss bar with a maximum progress of 100 (percent) and a current progress of 50%
	progressbar1 = LBG_create_progressbar (0, 64, 192, 256, 1, 1, 114, 4, "%.0f%%", &progressbar_bmaps, PBF_SHOW | PBF_SCALE, 100, 50);
	progressbar1->text->flags |= OUTLINE; // Enable the OUTLINE flag of the progressbar's text to make it always readable
	
	// Create a slider from 0 to 100. As a variable, we use the progress of the progressbar we've just created.
	LBG_SLIDER* slider1 = LBG_create_slider (0,64,256, 256, &slider_bmaps, 0, 100, &(progressbar1->progress), SF_SHOW | SF_EXTERNVAR);
	
	// Create an editbox
	LBG_EDITBOX* editbox1 = LBG_create_editbox (0, 64, 320, 256, 16, 4, "Editbox", LBG_ebmaps(editbox_left_tga,editbox_middle_tga,editbox_right_tga), EF_SHOW);
	LBG_editbox_set_text_color(editbox1,vector(0,192,0)); // Make its text green
	
	// Create an Infobox for the Editbox we just created.
	LBG_INFOBOX* infobox1 = LBG_create_infobox (editbox1, 1, 16, 16, 4, 4,"This is an editbox. If you reach the right end while typing, it just scrolls to the right.\nClick anywhere to put the cursor there.",&infobox_bmaps, IF_SHOW);
	vec_set(infobox1->text->blue,vector(0,192,0)); // Make its text green.
	
	
	// Create a listbox
	LBG_LISTBOX* listbox1 = LBG_create_listbox (0, 512, 32, 192, 256, 16, 16, 160, 224, &listbox_bmaps, LF_SHOW | LF_MULTIPLE | LF_UNSELECT);
	listbox1->tpos_x = 16; // This sets the text position of the items of this list relative to their positions
	listbox1->tpos_y = 1;
	listbox1->itemheight = 26; // This sets the height of the list items and thus the distance of two items. On default, the height is LBG_listitem_font.dy
	
	// Now, let's assign the bitmaps of the listitems. On default, they don't have any bitmaps
	listbox1->bmaps_over.bmap_left = listitem_over_left_tga; // This determines the bitmap of the list items, when the mouse is over them.
	listbox1->bmaps_over.bmap_middle = listitem_over_middle_tga;
	listbox1->bmaps_over.bmap_right = listitem_over_right_tga;
	listbox1->bmaps_marked.bmap_left = listitem_marked_left_tga; // This determines the bitmap of the list items, when they are selected.
	listbox1->bmaps_marked.bmap_middle = listitem_marked_middle_tga;
	listbox1->bmaps_marked.bmap_right = listitem_marked_right_tga;
	// There is also a bmaps_default, but in this case we don't want to have bitmaps when the mouse isn't over the list items.
	
	vec_set(listbox1->color_over,vector(255,255,0));	// When the mouse over a list item, its text should turn cyan
	vec_set(listbox1->color_marked,vector(0,255,255));	// When it's marked, it should be yellow.
	
	LBG_create_listitem (listbox1, 100, "Item 1", 0); // Now let's create the list items
	LBG_create_listitem (listbox1, 100, "Item 2", 0);
	LBG_create_listitem (listbox1, 100, "Item 3", 0);
	LBG_create_listitem (listbox1, 100, "Item 4", 0);
	LBG_create_listitem (listbox1, 100, "Item 5", 0);
	LBG_create_listitem (listbox1, 100, "Item 6", 0);
	LBG_create_listitem (listbox1, 100, "Item 7", 0);
	LBG_create_listitem (listbox1, 100, "Item 8", 0);
	LBG_create_listitem (listbox1, 100, "Item 9", 0);
	LBG_create_listitem (listbox1, 100, "Item 10", 0);
	
	// But all those items don't fit in the listbox! That's why we now create a scrollbar for the lisbox:
	LBG_VSCROLLBAR* listbox1_scrollbar = LBG_create_vscrollbar(listbox1, LBG_vsbmaps (vscrollbar_top_tga,vscrollbar_middle_tga,vscrollbar_bottom_tga,vscrollbar_bar_tga), LBG_bbmaps(vscrollbar_up1_tga,vscrollbar_up2_tga,vscrollbar_up3_tga,vscrollbar_up1_tga,vscrollbar_up2_tga,vscrollbar_up1_tga), LBG_bbmaps(vscrollbar_down1_tga,vscrollbar_down2_tga,vscrollbar_down3_tga,vscrollbar_down1_tga,vscrollbar_down2_tga,vscrollbar_down1_tga), VSF_SHOW);
	LBG_update_listbox(listbox1); // After changing the bitmaps and adding the scrollbar, the listbox needs to be updated.
	//If you add new items now, it also has to be updated; otherwise the scrollbar wouldn't "know" that there are now more list items.
	
	
	
	
	// Listboxes can also be parts of other GUI elements, such as comboboxes. Let's create one!
	LBG_COMBOBOX* combobox1 = LBG_create_combobox(0,512, 320, 256,16, 4, "Combobox", LBG_ebmaps(editbox_left_tga,editbox_middle_tga,editbox_right_tga), 16, 16, 224, &listbox_bmaps, LBG_bbmaps(combobox_button1_tga,combobox_button2_tga,combobox_button3_tga,combobox_button1_tga,combobox_button2_tga,combobox_button1_tga), CBF_SHOW);
	
	// Comboboxes have a member listbox called menu. To add options to the combobox, we just have to add items to its menu:
	LBG_create_listitem (combobox1->menu, 100, "Option 1", 0);
	LBG_create_listitem (combobox1->menu, 100, "Option 2", 0);
	LBG_create_listitem (combobox1->menu, 100, "Option 3", 0);
	LBG_create_listitem (combobox1->menu, 100, "Option 4", 0);
	
	// Of course we also have to do the same things to the combobox menu as to our "normal" listbox.
	// But this time, we only set its colors, leaving it without bitmaps. The itemheight it automatically set to LBG_listitem_font->dy.
	vec_set(combobox1->menu->color_default,vector(0,192,0));	// Green
	vec_set(combobox1->menu->color_over,vector(255,255,255));	// White
	vec_set(combobox1->menu->color_marked,vector(255,255,255));	// White
	
	// The text of the combobox is an editbox, that it disabled on default. Let's make its text green:
	LBG_editbox_set_text_color(combobox1->editbox,vector(0,192,0));
	
	LBG_update_combobox(combobox1); // When updating a combobox, its list gets updated, too.
	
	
	
	// Create a Digits Object that shows the progress of the progressbar above
	LBG_DIGITS* digits1 = LBG_create_digits (0, 64, 384, "The progress of the progressbar is %.1f%%.",&(progressbar1->progress), DF_SHOW | DF_EXTERNVAR);
	vec_set(digits1->text->blue,vector(0,192,0)); // Set the color of its text to green
	
	
	// Create a rightclick menu for the progress bar.
	LBG_RIGHTCLICK* rightclick1 = LBG_create_rightclick (progressbar1, 192, 16, 16, 160, &listbox_bmaps, RF_SHOW);
	// A rightclick menu also has a member listbox.
	
	// Add options to the rightclick menu. Unlike comboboxes, rightclick menus have their own function to add options, because they have functions.
	LBG_rightclick_add_option(rightclick1,255,"Set to 0%",0,progressbar1_set_to_0);
	LBG_rightclick_add_option(rightclick1,255,"Set to 100%",0,progressbar1_set_to_100);
	LBG_rightclick_add_option(rightclick1,255,"Increase by 10%",0,progressbar1_increase_by_10);
	LBG_rightclick_add_option(rightclick1,255,"Decrease by 10%",0,progressbar1_decrease_by_10);
	LBG_rightclick_add_option(rightclick1,255,"Beep",0,button_beep);
	
	// Add bitmaps
	rightclick1->menu->bmaps_over.bmap_left = listitem_over_left_tga;
	rightclick1->menu->bmaps_over.bmap_middle = listitem_over_middle_tga;
	rightclick1->menu->bmaps_over.bmap_right = listitem_over_right_tga;
	rightclick1->menu->bmaps_marked.bmap_left = listitem_marked_left_tga;
	rightclick1->menu->bmaps_marked.bmap_middle = listitem_marked_middle_tga;
	rightclick1->menu->bmaps_marked.bmap_right = listitem_marked_right_tga;
	
	rightclick1->menu->itemheight = 26; // Set the itemheight
	LBG_update_rightclick(rightclick1); // Update the rightclick menu
	
	
	// Create a resizable window with an X button and a maximize button.
	LBG_WINDOW* window1 = LBG_create_window(0, 96, 64, 512, 352, 12, 1,"Window",&win_bbmaps,&win_cbmaps,&win_tbmaps,1, 0, WF_SHOW | WF_XBUTTON | WF_MAXBUTTON | WF_RESIZABLE);
	window1->xbutton_offx = -25; // Set the position of the X button
	window1->xbutton_offy = 1;
	window1->minsize_x = 64; // Set the minimum size. On default it's the beginning size of the window.
	window1->minsize_y = 64;
	
	// Create an LBGUI panel in the window we have just created. Therefor we use pan1 as defined earlier as panel.
	LBG_create_panel (window1,32,32,pan1, PF_SHOW);
	
	// Create an LBGUI text in the window. Therefor we use txt1 as defined earlier as text.
	LBG_create_text(window1,128,32,txt1,TF_SHOW);
	
	
	
	////////
	radiobutton_windows_mouse = LBG_create_checkbox(0, 64, 472, 32, -4, "Windows cursor",&radiobutton_bmaps, CF_SHOW | CF_RADIO | CF_CHECKED);
	vec_set(radiobutton_windows_mouse->color_default,vector(0,192,0)); vec_set(radiobutton_windows_mouse->color_over,vector(0,212,0)); vec_set(radiobutton_windows_mouse->color_clicked,vector(0,192,0));
	
	radiobutton_bitmap_mouse = LBG_create_checkbox(0, 64, 504, 32, -4, "Bitmap cursor",&radiobutton_bmaps, CF_SHOW | CF_RADIO);
	vec_set(radiobutton_bitmap_mouse->color_default,vector(0,192,0)); vec_set(radiobutton_bitmap_mouse->color_over,vector(0,212,0)); vec_set(radiobutton_bitmap_mouse->color_clicked,vector(0,192,0));
	
	radiobutton_windows_mouse->group = 2;
	radiobutton_bitmap_mouse->group = 2;
}



//-------------------------------------------------------------------------------------------------------
// This function manages the mouse.
// LBG_mouse_cursor determines the mouse arrow to be shown.
// You always have to set your arrow by yourself. This it to make the mouse management more flexible
// (you can use the Windows mouse or a bitmap mouse or don't change the mouse at all)

void mouse_startup ()
{
	while(!radiobutton_windows_mouse) wait(1);
	while(1)
	{
		proc_mode = PROC_LATE; // Set the function to the end of the function list each frame
		//to assure that it's always at the end, even if an other function uses PROC_LATE
		
		if(radiobutton_windows_mouse->flags & CF_CHECKED) // If the user wants to use the Windows cursor
		{
			mouse_pan->flags &= ~SHOW;
			switch(LBG_mouse_cursor)
			{
				case 0: // Standard arrow
				mouse_pointer = 2;
				break;
				case 1: // Mouse is over a button (in this case, let's make it a hand)
				mouse_pointer = 1;
				break;
				case 2: // Horizontal window resize
				mouse_pointer = 8;
				break;
				case 3: // Vertical window resize
				mouse_pointer = 9;
				break;
				case 4: // Diagonal window resize (topleft-buttomright)
				mouse_pointer = 6;
				break;
				case 5: // Diagonal window resize (topright-buttomleft)
				mouse_pointer = 7;
				break;
				case 6: // Over an editbox
				mouse_pointer = 5;
				break;
			}
		}
		else // If the user wants to use a Bitmap cursor
		{
			/*As a "normal" bitmap mouse with mouse_spot didn't seem to work, I use a dummy mouse panel.
			You might want to do the same thing.*/
			mouse_pointer = 0;
			mouse_pan->flags |= SHOW;
			switch(LBG_mouse_cursor)
			{
				case 0: // Standard arrow
				mouse_pan->bmap = mouse_default_tga;
				mouse_spot.x = 0;
				mouse_spot.y = 0;
				break;
				case 1: // Mouse is over the button
				mouse_pan->bmap = mouse_default_tga;
				mouse_spot.x = 0;
				mouse_spot.y = 0;
				break;
				case 2: // Horizontal window resize
				mouse_pan->bmap = mouse_scale_hor_tga;
				mouse_spot.x = 7;
				mouse_spot.y = 7;
				break;
				case 3: // Vertical window resize
				mouse_pan->bmap = mouse_scale_ver_tga;
				mouse_spot.x = 7;
				mouse_spot.y = 7;
				break;
				case 4: // Diagonal window resize (topleft-buttomright)
				mouse_pan->bmap = mouse_scale_diag1_tga;
				mouse_spot.x = 7;
				mouse_spot.y = 7;
				break;
				case 5: // Diagonal window resize (topright-buttomleft)
				mouse_pan->bmap = mouse_scale_diag2_tga;
				mouse_spot.x = 7;
				mouse_spot.y = 7;
				break;
				case 6: // Over an editbox
				mouse_pan->bmap = mouse_text_tga;
				mouse_spot.x = 2;
				mouse_spot.y = 7;
				break;
			}
			mouse_pan->pos_x = mouse_pos.x-mouse_spot.x;
			mouse_pan->pos_y = mouse_pos.y-mouse_spot.y;
			mouse_pan->size_x = bmap_width(mouse_pan->bmap);
			mouse_pan->size_y = bmap_height(mouse_pan->bmap);
		}
		wait(1);
	}
}